; --------------------------------------------------------------
; Settings
;(set-option :mbqi true)
(set-option :macro-finder true)
(set-option :pull-nested-quantifiers true)
;(set-option :produce-unsat-cores true)
; --------------------------------------------------------------

(declare-datatypes () (
   (Obj
      (f_1)
      (f_2)
      (r)
      lastObj
      thisEvObj
      returnObj
      noObj
   )
))

(declare-datatypes () (
   (Name
      mtryLock
      cas
      unlock
      write
      read
      mlock
      this
   )
))

(declare-datatypes () (
   (Label
      W_02 W_2 C_1_Ret LAST C_2_Ret R_1 R_2 W_01 W_1 C_2_Inv C_1_Inv 
   )
))

(declare-datatypes () (
   (Var
      x_2 x_1 
   )
))

(declare-datatypes () (
   (Varl
      (var (unvar Var))
      (val (unval Int))
   )
))

(declare-fun valOf (Var) Int)

(declare-fun obj (Label) Obj)
(declare-fun method (Label) Name)
(declare-fun arg1 (Label) Varl)
(declare-fun arg2 (Label) Varl)
(declare-fun retv (Label) Var)
(declare-fun retEv (Label) Label)

(define-fun valOfVarl ((v Varl)) Int
   (ite
      (is-var v)
      (valOf (unvar v))
      (unval v)
   )
)
(define-fun validEq ((v1 Varl)(v2 Varl)) Bool
   (= (valOfVarl v1) (valOfVarl v2))
)


(declare-fun exec (Label) Bool)
(declare-fun /prec_p (Label Label) Bool)
(declare-fun /prec_X (Label Label) Bool)
(assert (exec LAST))
; ----------------------------------------------------------------
(assert
   (and
      (= (obj W_02) f_2)
      (= (method W_02) write)
      (= (arg1 W_02) (val 0))
   )
)

(assert
   (and
      (= (obj W_2) f_2)
      (= (method W_2) write)
      (= (arg1 W_2) (val 1))
   )
)

(assert
   (and
      (= (obj C_1_Ret) noObj)
      (or
         (/prec_X R_2 C_1_Inv)
         (/prec_X C_1_Ret R_2)
      )
      (or
         (/prec_X W_1 C_1_Inv)
         (/prec_X C_1_Ret W_1)
      )
   )
)

(assert
   (and
      (= (obj LAST) lastObj)
      (= (method LAST) read)
   )
)

(assert
   (and
      (= (obj C_2_Ret) noObj)
      (or
         (/prec_X W_2 C_2_Inv)
         (/prec_X C_2_Ret W_2)
      )
      (or
         (/prec_X R_1 C_2_Inv)
         (/prec_X C_2_Ret R_1)
      )
   )
)

(assert
   (and
      (= (obj R_1) f_1)
      (= (method R_1) read)
      (= (retv R_1) x_1)
   )
)

(assert
   (and
      (= (obj R_2) f_2)
      (= (method R_2) read)
      (= (retv R_2) x_2)
   )
)

(assert
   (and
      (= (obj W_01) f_1)
      (= (method W_01) write)
      (= (arg1 W_01) (val 0))
   )
)

(assert
   (and
      (= (obj W_1) f_1)
      (= (method W_1) write)
      (= (arg1 W_1) (val 1))
   )
)

(assert
   (and
      (= (obj C_2_Inv) r)
      (= (method C_2_Inv) write)
      (= (arg1 C_2_Inv) (val 2))
      (= (retEv C_2_Inv) C_2_Ret)
   )
)

(assert
   (and
      (= (obj C_1_Inv) r)
      (= (method C_1_Inv) write)
      (= (arg1 C_1_Inv) (val 1))
      (= (retEv C_1_Inv) C_1_Ret)
   )
)

(assert
   (exec W_02)
)

(assert
   (exec W_2)
)

(assert
   (iff
      (exec C_1_Ret)
      (and
         (= (valOf x_2) 1)
      )
   )
)

(assert
   (exec LAST)
)

(assert
   (iff
      (exec C_2_Ret)
      (and
         (= (valOf x_1) 0)
      )
   )
)

(assert
   (exec R_1)
)

(assert
   (exec R_2)
)

(assert
   (exec W_01)
)

(assert
   (exec W_1)
)

(assert
   (iff
      (exec C_2_Inv)
      (and
         (= (valOf x_1) 0)
      )
   )
)

(assert
   (iff
      (exec C_1_Inv)
      (and
         (= (valOf x_2) 1)
      )
   )
)

(assert
   (and
      (/prec_p W_02 C_1_Ret)
      (/prec_p W_02 W_2)
      (/prec_p W_02 R_1)
      (/prec_p W_02 LAST)
      (/prec_p W_02 C_2_Ret)
      (/prec_p W_02 R_2)
      (/prec_p W_02 W_1)
      (/prec_p W_02 C_2_Inv)
      (/prec_p W_02 C_1_Inv)
      (/prec_p W_2 LAST)
      (/prec_p W_2 C_2_Ret)
      (/prec_p W_2 R_1)
      (/prec_p W_2 C_2_Inv)
      (/prec_p C_1_Ret LAST)
      (/prec_p C_2_Ret LAST)
      (/prec_p R_1 LAST)
      (/prec_p R_1 C_2_Ret)
      (/prec_p R_1 C_2_Inv)
      (/prec_p R_2 C_1_Ret)
      (/prec_p R_2 LAST)
      (/prec_p R_2 C_1_Inv)
      (/prec_p W_01 C_1_Ret)
      (/prec_p W_01 W_2)
      (/prec_p W_01 R_1)
      (/prec_p W_01 LAST)
      (/prec_p W_01 C_2_Ret)
      (/prec_p W_01 R_2)
      (/prec_p W_01 W_1)
      (/prec_p W_01 C_2_Inv)
      (/prec_p W_01 C_1_Inv)
      (/prec_p W_1 C_1_Ret)
      (/prec_p W_1 LAST)
      (/prec_p W_1 R_2)
      (/prec_p W_1 C_1_Inv)
      (/prec_p C_2_Inv LAST)
      (/prec_p C_2_Inv C_2_Ret)
      (/prec_p C_1_Inv C_1_Ret)
      (/prec_p C_1_Inv LAST)
   )
)
; ----------------------------------------------------------------
; ----------------------------------------------------------------
; ----------------------------------------------------------------
; --------------------------------------------------------------
; /prec_X

; P2X
(assert
   (forall ((l1 Label) (l2 Label))
      (=> 
         (and
            (/prec_p l1 l2)
            (exec l1)
            (exec l2)
         )
         (/prec_X l1 l2)
      )
   )
)

; Total
(assert
   (forall ((l_1 Label) (l_2 Label))
      (=>
         (and
            (not (= l_1 l_2))
            (exec l_1)
            (exec l_2)
         )
         (or 
            (/prec_X l_1 l_2)
            (/prec_X l_2 l_1)
         )
      )
   )
)

; Transitive
(assert
   (forall ((l1 Label) (l2 Label) (l3 Label))
      (=>
         (and
            (/prec_X l1 l2)
            (/prec_X l2 l3)
         )
         (/prec_X l1 l3)
      )
   )
)

; Asymmetric
(assert
   (forall ((l1 Label) (l2 Label))
      (not
         (and 
            (/prec_X l1 l2)
            (/prec_X l2 l1)
         )
      )
   )
)

; --------------------------------------------------------------
; ----------------------------------------------------------------
(declare-fun /prec_f_1 ((Label) (Label)) Bool)

(assert
   (forall ((l_1 Label) (l_2 Label))
      (=>
         (and
            (= (obj l_1) f_1)
            (= (obj l_2) f_1)
         )
         (iff
            (/prec_X l_1 l_2)
            (/prec_f_1 l_1 l_2)
         )
      )
   )
)
; ----------------------------------------------------------------
; ----------------------------------------------------------------

(define-fun isRead_f_1 ((l_r Label)) Bool
   (and
      (exec l_r)
      (= (obj l_r) f_1)
      (= (method l_r) read)
   )
)
(define-fun isCAS_f_1 ((l_c Label)) Bool
   (and
      (exec l_c)
      (= (obj l_c) f_1)
      (= (method l_c) cas)
   )
)
(define-fun isWrite_f_1 ((l_w Label)) Bool
   (and
      (exec l_w)
      (= (obj l_w) f_1)
      (or
         (= (method l_w) write)
         (and
            (= (method l_w) cas)
            (= (valOf (retv l_w)) 1)
         )
      )
   )
)

(define-fun writtenVarl_f_1 ((l_w Label)) Varl
   (ite
      (= (method l_w) cas)
      (arg2 l_w)
      (arg1 l_w)
   )
)

(define-fun noWriteBetween_f_1_p ((l_w Label) (l_r Label) (l_w^ Label)) Bool
   (=>
      (isWrite_f_1 l_w^)
      (or
         (/prec_f_1 l_w^ l_w)
         (/prec_f_1 l_r l_w^)
         (= l_w l_w^)
      )
   )
)

(declare-fun noWriteBetween_f_1 ((Label) (Label)) Bool)
(assert
   (forall ((l_w Label) (l_r Label))
      (iff
         (noWriteBetween_f_1 l_w l_r)
         (and
            (noWriteBetween_f_1_p l_w l_r R_1)
            (noWriteBetween_f_1_p l_w l_r W_01)
            (noWriteBetween_f_1_p l_w l_r W_1)
         )
      )
   )
)


(define-fun isWriter_f_1 ((l_w Label)(l_r Label)) Bool
   (and
      (isWrite_f_1 l_w)
      (/prec_f_1 l_w l_r)
      (noWriteBetween_f_1 l_w l_r)
   )
)

(assert
   (forall ((l_r Label)(l_w Label))
      (=>
         (and
            (isRead_f_1 l_r)
            (isWriter_f_1 l_w l_r)
         )
         (validEq (var (retv l_r)) (writtenVarl_f_1 l_w))
      )
   )
)

(assert
   (forall ((l_c Label)(l_w Label))
      (=>
         (and
            (isCAS_f_1 l_c)
            (isWriter_f_1 l_w l_c)
         )
         (ite
            (validEq (arg1 l_c) (writtenVarl_f_1 l_w))
            (= (valOf (retv l_c)) 1)
            (= (valOf (retv l_c)) 0)
         )
      )
   )
)
; ----------------------------------------------------------------
; ----------------------------------------------------------------
(declare-fun /prec_f_2 ((Label) (Label)) Bool)

(assert
   (forall ((l_1 Label) (l_2 Label))
      (=>
         (and
            (= (obj l_1) f_2)
            (= (obj l_2) f_2)
         )
         (iff
            (/prec_X l_1 l_2)
            (/prec_f_2 l_1 l_2)
         )
      )
   )
)
; ----------------------------------------------------------------
; ----------------------------------------------------------------

(define-fun isRead_f_2 ((l_r Label)) Bool
   (and
      (exec l_r)
      (= (obj l_r) f_2)
      (= (method l_r) read)
   )
)
(define-fun isCAS_f_2 ((l_c Label)) Bool
   (and
      (exec l_c)
      (= (obj l_c) f_2)
      (= (method l_c) cas)
   )
)
(define-fun isWrite_f_2 ((l_w Label)) Bool
   (and
      (exec l_w)
      (= (obj l_w) f_2)
      (or
         (= (method l_w) write)
         (and
            (= (method l_w) cas)
            (= (valOf (retv l_w)) 1)
         )
      )
   )
)

(define-fun writtenVarl_f_2 ((l_w Label)) Varl
   (ite
      (= (method l_w) cas)
      (arg2 l_w)
      (arg1 l_w)
   )
)

(define-fun noWriteBetween_f_2_p ((l_w Label) (l_r Label) (l_w^ Label)) Bool
   (=>
      (isWrite_f_2 l_w^)
      (or
         (/prec_f_2 l_w^ l_w)
         (/prec_f_2 l_r l_w^)
         (= l_w l_w^)
      )
   )
)

(declare-fun noWriteBetween_f_2 ((Label) (Label)) Bool)
(assert
   (forall ((l_w Label) (l_r Label))
      (iff
         (noWriteBetween_f_2 l_w l_r)
         (and
            (noWriteBetween_f_2_p l_w l_r W_02)
            (noWriteBetween_f_2_p l_w l_r W_2)
            (noWriteBetween_f_2_p l_w l_r R_2)
         )
      )
   )
)


(define-fun isWriter_f_2 ((l_w Label)(l_r Label)) Bool
   (and
      (isWrite_f_2 l_w)
      (/prec_f_2 l_w l_r)
      (noWriteBetween_f_2 l_w l_r)
   )
)

(assert
   (forall ((l_r Label)(l_w Label))
      (=>
         (and
            (isRead_f_2 l_r)
            (isWriter_f_2 l_w l_r)
         )
         (validEq (var (retv l_r)) (writtenVarl_f_2 l_w))
      )
   )
)

(assert
   (forall ((l_c Label)(l_w Label))
      (=>
         (and
            (isCAS_f_2 l_c)
            (isWriter_f_2 l_w l_c)
         )
         (ite
            (validEq (arg1 l_c) (writtenVarl_f_2 l_w))
            (= (valOf (retv l_c)) 1)
            (= (valOf (retv l_c)) 0)
         )
      )
   )
)
; ----------------------------------------------------------------
; ----------------------------------------------------------------

(define-fun isSeq_r () Bool
   (forall ((l1 Label) (l2 Label))
      (=>
         (and
            (= (obj l1) r)
            (= (obj l2) r)
         )
         (or
            (= l1 l2)
            (/prec_X (retEv l1) l2)
            (/prec_X (retEv l2) l1)
         )
      )
   )
)

(define-fun isRead_X_r ((l_r Label)) Bool
   (and
      (exec l_r)
      (= (obj l_r) r)
      (= (method l_r) read)
   )
)
(define-fun isWrite_X_r ((l_w Label)) Bool
   (and
      (exec l_w)
      (= (obj l_w) r)
      (= (method l_w) write)
   )
)

(define-fun noWriteBetween_X_r_p ((l_w Label) (l_r Label) (l_w^ Label)) Bool
   (=>
      (isWrite_X_r l_w^)
      (or
         (/prec_X l_w^ l_w)
         (/prec_X l_r l_w^)
         (= l_w l_w^)
      )
   )
)

(declare-fun noWriteBetween_X_r ((Label) (Label)) Bool)
(assert
   (forall ((l_w Label) (l_r Label))
      (iff
         (noWriteBetween_X_r l_w l_r)
         (and
            (noWriteBetween_X_r_p l_w l_r C_2_Inv)
            (noWriteBetween_X_r_p l_w l_r C_1_Inv)
         )
      )
   )
)


(define-fun isWriter_X_r ((l_w Label)(l_r Label)) Bool
   (and
      (isWrite_X_r l_w)
      (/prec_X l_w l_r)
      (noWriteBetween_X_r l_w l_r)
   )
)

(assert
   (forall ((l_r Label)(l_w Label))
      (=>
         (and
            isSeq_r
            (isRead_X_r l_r)
            (isWriter_X_r l_w l_r)
         )
         (validEq (var (retv l_r)) (arg1 l_w))
      )
   )
)

; ----------------------------------------------------------------
(define-fun bug () Bool
   (not
      (not (and (exec C_1_Inv) (exec C_2_Inv)))
   )
)
(assert bug)
(check-sat)  ; Should print sat

(echo "--------------------------------------")
(eval (exec W_02))
(eval (exec W_2))
(eval (exec C_1_Ret))
(eval (exec LAST))
(eval (exec C_2_Ret))
(eval (exec R_1))
(eval (exec R_2))
(eval (exec W_01))
(eval (exec W_1))
(eval (exec C_2_Inv))
(eval (exec C_1_Inv))
(echo "--------------------------------------")
(eval (valOf x_2))
(eval (valOf x_1))
(echo "--------------------------------------")
(eval (/prec_X W_02 W_02))
(eval (/prec_X W_02 W_2))
(eval (/prec_X W_02 C_1_Ret))
(eval (/prec_X W_02 LAST))
(eval (/prec_X W_02 C_2_Ret))
(eval (/prec_X W_02 R_1))
(eval (/prec_X W_02 R_2))
(eval (/prec_X W_02 W_01))
(eval (/prec_X W_02 W_1))
(eval (/prec_X W_02 C_2_Inv))
(eval (/prec_X W_02 C_1_Inv))
(eval (/prec_X W_2 W_02))
(eval (/prec_X W_2 W_2))
(eval (/prec_X W_2 C_1_Ret))
(eval (/prec_X W_2 LAST))
(eval (/prec_X W_2 C_2_Ret))
(eval (/prec_X W_2 R_1))
(eval (/prec_X W_2 R_2))
(eval (/prec_X W_2 W_01))
(eval (/prec_X W_2 W_1))
(eval (/prec_X W_2 C_2_Inv))
(eval (/prec_X W_2 C_1_Inv))
(eval (/prec_X C_1_Ret W_02))
(eval (/prec_X C_1_Ret W_2))
(eval (/prec_X C_1_Ret C_1_Ret))
(eval (/prec_X C_1_Ret LAST))
(eval (/prec_X C_1_Ret C_2_Ret))
(eval (/prec_X C_1_Ret R_1))
(eval (/prec_X C_1_Ret R_2))
(eval (/prec_X C_1_Ret W_01))
(eval (/prec_X C_1_Ret W_1))
(eval (/prec_X C_1_Ret C_2_Inv))
(eval (/prec_X C_1_Ret C_1_Inv))
(eval (/prec_X LAST W_02))
(eval (/prec_X LAST W_2))
(eval (/prec_X LAST C_1_Ret))
(eval (/prec_X LAST LAST))
(eval (/prec_X LAST C_2_Ret))
(eval (/prec_X LAST R_1))
(eval (/prec_X LAST R_2))
(eval (/prec_X LAST W_01))
(eval (/prec_X LAST W_1))
(eval (/prec_X LAST C_2_Inv))
(eval (/prec_X LAST C_1_Inv))
(eval (/prec_X C_2_Ret W_02))
(eval (/prec_X C_2_Ret W_2))
(eval (/prec_X C_2_Ret C_1_Ret))
(eval (/prec_X C_2_Ret LAST))
(eval (/prec_X C_2_Ret C_2_Ret))
(eval (/prec_X C_2_Ret R_1))
(eval (/prec_X C_2_Ret R_2))
(eval (/prec_X C_2_Ret W_01))
(eval (/prec_X C_2_Ret W_1))
(eval (/prec_X C_2_Ret C_2_Inv))
(eval (/prec_X C_2_Ret C_1_Inv))
(eval (/prec_X R_1 W_02))
(eval (/prec_X R_1 W_2))
(eval (/prec_X R_1 C_1_Ret))
(eval (/prec_X R_1 LAST))
(eval (/prec_X R_1 C_2_Ret))
(eval (/prec_X R_1 R_1))
(eval (/prec_X R_1 R_2))
(eval (/prec_X R_1 W_01))
(eval (/prec_X R_1 W_1))
(eval (/prec_X R_1 C_2_Inv))
(eval (/prec_X R_1 C_1_Inv))
(eval (/prec_X R_2 W_02))
(eval (/prec_X R_2 W_2))
(eval (/prec_X R_2 C_1_Ret))
(eval (/prec_X R_2 LAST))
(eval (/prec_X R_2 C_2_Ret))
(eval (/prec_X R_2 R_1))
(eval (/prec_X R_2 R_2))
(eval (/prec_X R_2 W_01))
(eval (/prec_X R_2 W_1))
(eval (/prec_X R_2 C_2_Inv))
(eval (/prec_X R_2 C_1_Inv))
(eval (/prec_X W_01 W_02))
(eval (/prec_X W_01 W_2))
(eval (/prec_X W_01 C_1_Ret))
(eval (/prec_X W_01 LAST))
(eval (/prec_X W_01 C_2_Ret))
(eval (/prec_X W_01 R_1))
(eval (/prec_X W_01 R_2))
(eval (/prec_X W_01 W_01))
(eval (/prec_X W_01 W_1))
(eval (/prec_X W_01 C_2_Inv))
(eval (/prec_X W_01 C_1_Inv))
(eval (/prec_X W_1 W_02))
(eval (/prec_X W_1 W_2))
(eval (/prec_X W_1 C_1_Ret))
(eval (/prec_X W_1 LAST))
(eval (/prec_X W_1 C_2_Ret))
(eval (/prec_X W_1 R_1))
(eval (/prec_X W_1 R_2))
(eval (/prec_X W_1 W_01))
(eval (/prec_X W_1 W_1))
(eval (/prec_X W_1 C_2_Inv))
(eval (/prec_X W_1 C_1_Inv))
(eval (/prec_X C_2_Inv W_02))
(eval (/prec_X C_2_Inv W_2))
(eval (/prec_X C_2_Inv C_1_Ret))
(eval (/prec_X C_2_Inv LAST))
(eval (/prec_X C_2_Inv C_2_Ret))
(eval (/prec_X C_2_Inv R_1))
(eval (/prec_X C_2_Inv R_2))
(eval (/prec_X C_2_Inv W_01))
(eval (/prec_X C_2_Inv W_1))
(eval (/prec_X C_2_Inv C_2_Inv))
(eval (/prec_X C_2_Inv C_1_Inv))
(eval (/prec_X C_1_Inv W_02))
(eval (/prec_X C_1_Inv W_2))
(eval (/prec_X C_1_Inv C_1_Ret))
(eval (/prec_X C_1_Inv LAST))
(eval (/prec_X C_1_Inv C_2_Ret))
(eval (/prec_X C_1_Inv R_1))
(eval (/prec_X C_1_Inv R_2))
(eval (/prec_X C_1_Inv W_01))
(eval (/prec_X C_1_Inv W_1))
(eval (/prec_X C_1_Inv C_2_Inv))
(eval (/prec_X C_1_Inv C_1_Inv))
(echo "--------------------------------------")
