; --------------------------------------------------------------
; Settings
;(set-option :mbqi true)
(set-option :macro-finder true)
(set-option :pull-nested-quantifiers true)
;(set-option :produce-unsat-cores true)
; --------------------------------------------------------------

(declare-datatypes () (
   (Obj
      (b1)
      (b2)
      (lock)
      lastObj
      thisEvObj
      returnObj
      noObj
   )
))

(declare-datatypes () (
   (Name
      mtryLock
      cas
      transfer
      unlock
      ~this
      write
      read
      mlock
      this
   )
))

(declare-datatypes () (
   (Label
      T1.R1 T2.W1 T2.W2 T1_Inv T2_Ret T1.C1 LAST T1.W2 T1.F T2.C1 T1.W1 T2.R2 T2.C2 T2.F T2.L T1.R2 T1_Ret DR T2_Inv T1.U T1.C2 T2.R1 IW1 IW2 T1.L T2.U 
   )
))

(declare-datatypes () (
   (Var
      v
      T2.c4
      T2.c3
      T2.c2
      T2.c1
      T1.a
      T2.a
      T1.c1
      T1.c2
      T1.t
      T1.c3
      T1.c4
      T2.t
   )
))

(declare-datatypes () (
   (Varl
      (var (unvar Var))
      (val (unval Int))
   )
))

(declare-fun valOf (Var) Int)

(declare-fun obj (Label) Obj)
(declare-fun method (Label) Name)
(declare-fun arg1 (Label) Varl)
(declare-fun arg2 (Label) Varl)
(declare-fun retv (Label) Var)
(declare-fun retEv (Label) Label)

(define-fun valOfVarl ((v Varl)) Int
   (ite
      (is-var v)
      (valOf (unvar v))
      (unval v)
   )
)
(define-fun validEq ((v1 Varl)(v2 Varl)) Bool
   (= (valOfVarl v1) (valOfVarl v2))
)


(declare-fun exec (Label) Bool)
(declare-fun /prec_p (Label Label) Bool)
(declare-fun /prec_X (Label Label) Bool)
(assert (exec LAST))
; ----------------------------------------------------------------
(assert
   (and
      (= (obj T1.R1) b1)
      (= (method T1.R1) read)
      (= (retv T1.R1) T1.c1)
   )
)

(assert
   (and
      (= (obj T2.W1) b1)
      (= (method T2.W1) write)
      (= (arg1 T2.W1) (var T2.c3))
   )
)

(assert
   (and
      (= (obj T2.W2) b2)
      (= (method T2.W2) write)
      (= (arg1 T2.W2) (var T2.c4))
   )
)

(assert
   (and
      (= (obj T1_Inv) thisEvObj)
      (= (method T1_Inv) transfer)
      (= (arg1 T1_Inv) (val 10))
   )
)

(assert
   (and
      (= (obj T2_Ret) thisEvObj)
      (= (method T2_Ret) transfer)
   )
)

(assert
   (and
      (= (obj T1.C1) noObj)
   )
)

(assert
   (and
      (= (obj LAST) lastObj)
      (= (method LAST) read)
   )
)

(assert
   (and
      (= (obj T1.W2) b2)
      (= (method T1.W2) write)
      (= (arg1 T1.W2) (var T1.c4))
   )
)

(assert
   (and
      (= (obj T1.F) returnObj)
      (= (method T1.F) read)
   )
)

(assert
   (and
      (= (obj T2.C1) noObj)
   )
)

(assert
   (and
      (= (obj T1.W1) b1)
      (= (method T1.W1) write)
      (= (arg1 T1.W1) (var T1.c3))
   )
)

(assert
   (and
      (= (obj T2.R2) b2)
      (= (method T2.R2) read)
      (= (retv T2.R2) T2.c2)
   )
)

(assert
   (and
      (= (obj T2.C2) noObj)
   )
)

(assert
   (and
      (= (obj T2.F) returnObj)
      (= (method T2.F) read)
   )
)

(assert
   (and
      (= (obj T2.L) lock)
      (= (method T2.L) mlock)
   )
)

(assert
   (and
      (= (obj T1.R2) b2)
      (= (method T1.R2) read)
      (= (retv T1.R2) T1.c2)
   )
)

(assert
   (and
      (= (obj T1_Ret) thisEvObj)
      (= (method T1_Ret) transfer)
   )
)

(assert
   (and
      (= (obj DR) b2)
      (= (method DR) read)
      (= (retv DR) v)
   )
)

(assert
   (and
      (= (obj T2_Inv) thisEvObj)
      (= (method T2_Inv) transfer)
      (= (arg1 T2_Inv) (val 10))
   )
)

(assert
   (and
      (= (obj T1.U) lock)
      (= (method T1.U) unlock)
   )
)

(assert
   (and
      (= (obj T1.C2) noObj)
   )
)

(assert
   (and
      (= (obj T2.R1) b1)
      (= (method T2.R1) read)
      (= (retv T2.R1) T2.c1)
   )
)

(assert
   (and
      (= (obj IW1) b1)
      (= (method IW1) write)
      (= (arg1 IW1) (val 100))
   )
)

(assert
   (and
      (= (obj IW2) b2)
      (= (method IW2) write)
      (= (arg1 IW2) (val 100))
   )
)

(assert
   (and
      (= (obj T1.L) lock)
      (= (method T1.L) mlock)
   )
)

(assert
   (and
      (= (obj T2.U) lock)
      (= (method T2.U) unlock)
   )
)

(assert
   (exec T1.R1)
)

(assert
   (exec T2.W1)
)

(assert
   (exec T2.W2)
)

(assert
   (exec T1_Inv)
)

(assert
   (exec T2_Ret)
)

(assert
   (exec T1.C1)
)

(assert
   (exec LAST)
)

(assert
   (exec T1.W2)
)

(assert
   (exec T1.F)
)

(assert
   (exec T2.C1)
)

(assert
   (exec T1.W1)
)

(assert
   (exec T2.R2)
)

(assert
   (exec T2.C2)
)

(assert
   (exec T2.F)
)

(assert
   (exec T2.L)
)

(assert
   (exec T1.R2)
)

(assert
   (exec T1_Ret)
)

(assert
   (exec DR)
)

(assert
   (exec T2_Inv)
)

(assert
   (exec T1.U)
)

(assert
   (exec T1.C2)
)

(assert
   (exec T2.R1)
)

(assert
   (exec IW1)
)

(assert
   (exec IW2)
)

(assert
   (exec T1.L)
)

(assert
   (exec T2.U)
)

(assert
   (=>
      (exec T1.C2)
      (=
         (valOf T1.c4)
         (+
            (valOf T1.c2)
            (valOf T1.a)
         )
      )
   )
)
(assert
   (=>
      (exec T2.C2)
      (=
         (valOf T2.c4)
         (+
            (valOf T2.c2)
            (valOf T2.a)
         )
      )
   )
)
(assert
   (=>
      (exec T1.C1)
      (=
         (valOf T1.c3)
         (-
            (valOf T1.c1)
            (valOf T1.a)
         )
      )
   )
)
(assert
   (=>
      (exec T2.C1)
      (=
         (valOf T2.c3)
         (-
            (valOf T2.c1)
            (valOf T2.a)
         )
      )
   )
)
(assert
   (and
      (/prec_p T1.R1 DR)
      (/prec_p T1.R1 T1.W1)
      (/prec_p T1.R1 T1.U)
      (/prec_p T1.R1 T1.C1)
      (/prec_p T1.R1 LAST)
      (/prec_p T1.R1 T1_Ret)
      (/prec_p T1.R1 T1.F)
      (/prec_p T2.W1 DR)
      (/prec_p T2.W1 T2_Ret)
      (/prec_p T2.W1 T2.F)
      (/prec_p T2.W1 LAST)
      (/prec_p T2.W1 T2.U)
      (/prec_p T2.W2 DR)
      (/prec_p T2.W2 T2_Ret)
      (/prec_p T2.W2 T2.F)
      (/prec_p T2.W2 LAST)
      (/prec_p T2.W2 T2.U)
      (/prec_p T1_Inv DR)
      (/prec_p T1_Inv T1.W1)
      (/prec_p T1_Inv T1.U)
      (/prec_p T1_Inv T1.C2)
      (/prec_p T1_Inv T1.L)
      (/prec_p T1_Inv T1.R1)
      (/prec_p T1_Inv T1.C1)
      (/prec_p T1_Inv LAST)
      (/prec_p T1_Inv T1.W2)
      (/prec_p T1_Inv T1.R2)
      (/prec_p T1_Inv T1.F)
      (/prec_p T2_Ret DR)
      (/prec_p T2_Ret LAST)
      (/prec_p T1.C1 DR)
      (/prec_p T1.C1 T1.W1)
      (/prec_p T1.C1 T1.U)
      (/prec_p T1.C1 LAST)
      (/prec_p T1.C1 T1_Ret)
      (/prec_p T1.C1 T1.F)
      (/prec_p T1.W2 DR)
      (/prec_p T1.W2 T1.U)
      (/prec_p T1.W2 LAST)
      (/prec_p T1.W2 T1_Ret)
      (/prec_p T1.W2 T1.F)
      (/prec_p T1.F DR)
      (/prec_p T1.F LAST)
      (/prec_p T1.F T1_Ret)
      (/prec_p T2.C1 DR)
      (/prec_p T2.C1 T2_Ret)
      (/prec_p T2.C1 T2.F)
      (/prec_p T2.C1 T2.W1)
      (/prec_p T2.C1 LAST)
      (/prec_p T2.C1 T2.U)
      (/prec_p T1.W1 DR)
      (/prec_p T1.W1 T1.U)
      (/prec_p T1.W1 LAST)
      (/prec_p T1.W1 T1_Ret)
      (/prec_p T1.W1 T1.F)
      (/prec_p T2.R2 DR)
      (/prec_p T2.R2 T2_Ret)
      (/prec_p T2.R2 T2.C2)
      (/prec_p T2.R2 T2.F)
      (/prec_p T2.R2 T2.W2)
      (/prec_p T2.R2 LAST)
      (/prec_p T2.R2 T2.U)
      (/prec_p T2.C2 DR)
      (/prec_p T2.C2 T2_Ret)
      (/prec_p T2.C2 T2.F)
      (/prec_p T2.C2 T2.W2)
      (/prec_p T2.C2 LAST)
      (/prec_p T2.C2 T2.U)
      (/prec_p T2.F DR)
      (/prec_p T2.F T2_Ret)
      (/prec_p T2.F LAST)
      (/prec_p T2.L DR)
      (/prec_p T2.L T2.R2)
      (/prec_p T2.L T2.R1)
      (/prec_p T2.L T2_Ret)
      (/prec_p T2.L T2.C2)
      (/prec_p T2.L T2.F)
      (/prec_p T2.L T2.W2)
      (/prec_p T2.L T2.W1)
      (/prec_p T2.L LAST)
      (/prec_p T2.L T2.U)
      (/prec_p T2.L T2.C1)
      (/prec_p T1.R2 DR)
      (/prec_p T1.R2 T1.U)
      (/prec_p T1.R2 T1.C2)
      (/prec_p T1.R2 LAST)
      (/prec_p T1.R2 T1.W2)
      (/prec_p T1.R2 T1_Ret)
      (/prec_p T1.R2 T1.F)
      (/prec_p T1_Ret DR)
      (/prec_p T1_Ret LAST)
      (/prec_p DR LAST)
      (/prec_p T2_Inv DR)
      (/prec_p T2_Inv T2.R1)
      (/prec_p T2_Inv T2.R2)
      (/prec_p T2_Inv T2.C2)
      (/prec_p T2_Inv T2.F)
      (/prec_p T2_Inv T2.L)
      (/prec_p T2_Inv T2.W1)
      (/prec_p T2_Inv T2.W2)
      (/prec_p T2_Inv LAST)
      (/prec_p T2_Inv T2.U)
      (/prec_p T2_Inv T2.C1)
      (/prec_p T1.U DR)
      (/prec_p T1.U LAST)
      (/prec_p T1.U T1_Ret)
      (/prec_p T1.U T1.F)
      (/prec_p T1.C2 DR)
      (/prec_p T1.C2 T1.U)
      (/prec_p T1.C2 LAST)
      (/prec_p T1.C2 T1.W2)
      (/prec_p T1.C2 T1_Ret)
      (/prec_p T1.C2 T1.F)
      (/prec_p T2.R1 DR)
      (/prec_p T2.R1 T2_Ret)
      (/prec_p T2.R1 T2.F)
      (/prec_p T2.R1 T2.W1)
      (/prec_p T2.R1 LAST)
      (/prec_p T2.R1 T2.U)
      (/prec_p T2.R1 T2.C1)
      (/prec_p IW1 T1.W1)
      (/prec_p IW1 T2.R2)
      (/prec_p IW1 T2.C2)
      (/prec_p IW1 T2.F)
      (/prec_p IW1 T2.L)
      (/prec_p IW1 T1.R1)
      (/prec_p IW1 T2.W1)
      (/prec_p IW1 T2.W2)
      (/prec_p IW1 T1.R2)
      (/prec_p IW1 T1_Ret)
      (/prec_p IW1 T2_Inv)
      (/prec_p IW1 T1.U)
      (/prec_p IW1 DR)
      (/prec_p IW1 T1.C2)
      (/prec_p IW1 T1_Inv)
      (/prec_p IW1 T2.R1)
      (/prec_p IW1 T2_Ret)
      (/prec_p IW1 T1.L)
      (/prec_p IW1 T1.C1)
      (/prec_p IW1 LAST)
      (/prec_p IW1 T1.W2)
      (/prec_p IW1 T2.U)
      (/prec_p IW1 T1.F)
      (/prec_p IW1 T2.C1)
      (/prec_p IW2 T1.W1)
      (/prec_p IW2 T2.R2)
      (/prec_p IW2 T2.C2)
      (/prec_p IW2 T2.F)
      (/prec_p IW2 T2.L)
      (/prec_p IW2 T1.R1)
      (/prec_p IW2 T2.W1)
      (/prec_p IW2 T2.W2)
      (/prec_p IW2 T1.R2)
      (/prec_p IW2 T1_Ret)
      (/prec_p IW2 T2_Inv)
      (/prec_p IW2 T1.U)
      (/prec_p IW2 DR)
      (/prec_p IW2 T1.C2)
      (/prec_p IW2 T1_Inv)
      (/prec_p IW2 T2.R1)
      (/prec_p IW2 T2_Ret)
      (/prec_p IW2 T1.L)
      (/prec_p IW2 T1.C1)
      (/prec_p IW2 LAST)
      (/prec_p IW2 T1.W2)
      (/prec_p IW2 T2.U)
      (/prec_p IW2 T1.F)
      (/prec_p IW2 T2.C1)
      (/prec_p T1.L DR)
      (/prec_p T1.L T1.U)
      (/prec_p T1.L T1.W1)
      (/prec_p T1.L T1.C2)
      (/prec_p T1.L T1.C1)
      (/prec_p T1.L T1.R1)
      (/prec_p T1.L LAST)
      (/prec_p T1.L T1.W2)
      (/prec_p T1.L T1_Ret)
      (/prec_p T1.L T1.R2)
      (/prec_p T1.L T1.F)
      (/prec_p T2.U DR)
      (/prec_p T2.U T2_Ret)
      (/prec_p T2.U T2.F)
      (/prec_p T2.U LAST)
   )
)
; ----------------------------------------------------------------
; ----------------------------------------------------------------
(assert
   (and
      (= (valOf T2.t) 2)
      (= (valOf T2.a) 10)
   )
)
(assert
   (iff
      (exec T2_Ret)
         (or
         (and
            (exec T2.F)
            )
      )
   )
)

(assert
   (iff
      (exec T2_Inv)
      (exec T2_Ret)
   )
)

(assert
   (and
      (= (valOf T1.t) 1)
      (= (valOf T1.a) 10)
   )
)
(assert
   (iff
      (exec T1_Ret)
         (or
         (and
            (exec T1.F)
            )
      )
   )
)

(assert
   (iff
      (exec T1_Inv)
      (exec T1_Ret)
   )
)

; ----------------------------------------------------------------
; --------------------------------------------------------------
; /prec_X

; P2X
(assert
   (forall ((l1 Label) (l2 Label))
      (=> 
         (and
            (/prec_p l1 l2)
            (exec l1)
            (exec l2)
         )
         (/prec_X l1 l2)
      )
   )
)

; Total
(assert
   (forall ((l_1 Label) (l_2 Label))
      (=>
         (and
            (not (= l_1 l_2))
            (exec l_1)
            (exec l_2)
         )
         (or 
            (/prec_X l_1 l_2)
            (/prec_X l_2 l_1)
         )
      )
   )
)

; Transitive
(assert
   (forall ((l1 Label) (l2 Label) (l3 Label))
      (=>
         (and
            (/prec_X l1 l2)
            (/prec_X l2 l3)
         )
         (/prec_X l1 l3)
      )
   )
)

; Asymmetric
(assert
   (forall ((l1 Label) (l2 Label))
      (not
         (and 
            (/prec_X l1 l2)
            (/prec_X l2 l1)
         )
      )
   )
)

; --------------------------------------------------------------
; ----------------------------------------------------------------
(declare-fun /prec_b1 ((Label) (Label)) Bool)

(assert
   (forall ((l_1 Label) (l_2 Label))
      (=>
         (and
            (= (obj l_1) b1)
            (= (obj l_2) b1)
         )
         (iff
            (/prec_X l_1 l_2)
            (/prec_b1 l_1 l_2)
         )
      )
   )
)
; ----------------------------------------------------------------
; ----------------------------------------------------------------

(define-fun isRead_b1 ((l_r Label)) Bool
   (and
      (exec l_r)
      (= (obj l_r) b1)
      (= (method l_r) read)
   )
)
(define-fun isCAS_b1 ((l_c Label)) Bool
   (and
      (exec l_c)
      (= (obj l_c) b1)
      (= (method l_c) cas)
   )
)
(define-fun isWrite_b1 ((l_w Label)) Bool
   (and
      (exec l_w)
      (= (obj l_w) b1)
      (or
         (= (method l_w) write)
         (and
            (= (method l_w) cas)
            (= (valOf (retv l_w)) 1)
         )
      )
   )
)

(define-fun writtenVarl_b1 ((l_w Label)) Varl
   (ite
      (= (method l_w) cas)
      (arg2 l_w)
      (arg1 l_w)
   )
)

(define-fun noWriteBetween_b1_p ((l_w Label) (l_r Label) (l_w^ Label)) Bool
   (=>
      (isWrite_b1 l_w^)
      (or
         (/prec_b1 l_w^ l_w)
         (/prec_b1 l_r l_w^)
         (= l_w l_w^)
      )
   )
)

(declare-fun noWriteBetween_b1 ((Label) (Label)) Bool)
(assert
   (forall ((l_w Label) (l_r Label))
      (iff
         (noWriteBetween_b1 l_w l_r)
         (and
            (noWriteBetween_b1_p l_w l_r T1.R1)
            (noWriteBetween_b1_p l_w l_r T2.W1)
            (noWriteBetween_b1_p l_w l_r T1.W1)
            (noWriteBetween_b1_p l_w l_r T2.R1)
            (noWriteBetween_b1_p l_w l_r IW1)
         )
      )
   )
)


(define-fun isWriter_b1 ((l_w Label)(l_r Label)) Bool
   (and
      (isWrite_b1 l_w)
      (/prec_b1 l_w l_r)
      (noWriteBetween_b1 l_w l_r)
   )
)

(assert
   (forall ((l_r Label)(l_w Label))
      (=>
         (and
            (isRead_b1 l_r)
            (isWriter_b1 l_w l_r)
         )
         (validEq (var (retv l_r)) (writtenVarl_b1 l_w))
      )
   )
)

(assert
   (forall ((l_c Label)(l_w Label))
      (=>
         (and
            (isCAS_b1 l_c)
            (isWriter_b1 l_w l_c)
         )
         (ite
            (validEq (arg1 l_c) (writtenVarl_b1 l_w))
            (= (valOf (retv l_c)) 1)
            (= (valOf (retv l_c)) 0)
         )
      )
   )
)
; ----------------------------------------------------------------
; ----------------------------------------------------------------
(declare-fun /prec_b2 ((Label) (Label)) Bool)

(assert
   (forall ((l_1 Label) (l_2 Label))
      (=>
         (and
            (= (obj l_1) b2)
            (= (obj l_2) b2)
         )
         (iff
            (/prec_X l_1 l_2)
            (/prec_b2 l_1 l_2)
         )
      )
   )
)
; ----------------------------------------------------------------
; ----------------------------------------------------------------

(define-fun isRead_b2 ((l_r Label)) Bool
   (and
      (exec l_r)
      (= (obj l_r) b2)
      (= (method l_r) read)
   )
)
(define-fun isCAS_b2 ((l_c Label)) Bool
   (and
      (exec l_c)
      (= (obj l_c) b2)
      (= (method l_c) cas)
   )
)
(define-fun isWrite_b2 ((l_w Label)) Bool
   (and
      (exec l_w)
      (= (obj l_w) b2)
      (or
         (= (method l_w) write)
         (and
            (= (method l_w) cas)
            (= (valOf (retv l_w)) 1)
         )
      )
   )
)

(define-fun writtenVarl_b2 ((l_w Label)) Varl
   (ite
      (= (method l_w) cas)
      (arg2 l_w)
      (arg1 l_w)
   )
)

(define-fun noWriteBetween_b2_p ((l_w Label) (l_r Label) (l_w^ Label)) Bool
   (=>
      (isWrite_b2 l_w^)
      (or
         (/prec_b2 l_w^ l_w)
         (/prec_b2 l_r l_w^)
         (= l_w l_w^)
      )
   )
)

(declare-fun noWriteBetween_b2 ((Label) (Label)) Bool)
(assert
   (forall ((l_w Label) (l_r Label))
      (iff
         (noWriteBetween_b2 l_w l_r)
         (and
            (noWriteBetween_b2_p l_w l_r T2.W2)
            (noWriteBetween_b2_p l_w l_r T1.W2)
            (noWriteBetween_b2_p l_w l_r T2.R2)
            (noWriteBetween_b2_p l_w l_r T1.R2)
            (noWriteBetween_b2_p l_w l_r DR)
            (noWriteBetween_b2_p l_w l_r IW2)
         )
      )
   )
)


(define-fun isWriter_b2 ((l_w Label)(l_r Label)) Bool
   (and
      (isWrite_b2 l_w)
      (/prec_b2 l_w l_r)
      (noWriteBetween_b2 l_w l_r)
   )
)

(assert
   (forall ((l_r Label)(l_w Label))
      (=>
         (and
            (isRead_b2 l_r)
            (isWriter_b2 l_w l_r)
         )
         (validEq (var (retv l_r)) (writtenVarl_b2 l_w))
      )
   )
)

(assert
   (forall ((l_c Label)(l_w Label))
      (=>
         (and
            (isCAS_b2 l_c)
            (isWriter_b2 l_w l_c)
         )
         (ite
            (validEq (arg1 l_c) (writtenVarl_b2 l_w))
            (= (valOf (retv l_c)) 1)
            (= (valOf (retv l_c)) 0)
         )
      )
   )
)
; ----------------------------------------------------------------
; ----------------------------------------------------------------
(declare-fun /prec_lock ((Label) (Label)) Bool)

(assert
   (forall ((l_1 Label) (l_2 Label))
      (=>
         (and
            (= (obj l_1) lock)
            (= (obj l_2) lock)
         )
         (iff
            (/prec_X l_1 l_2)
            (/prec_lock l_1 l_2)
         )
      )
   )
)
; ----------------------------------------------------------------
; ----------------------------------------------------------------
(define-fun isLock_lock ((l_l Label)) Bool
   (and
      (exec l_l)
      (= (obj l_l) lock)
      (= (method l_l) mlock)
   )
)
(define-fun isUnlock_lock ((l_u Label)) Bool
   (and
      (exec l_u)
      (= (obj l_u) lock)
      (= (method l_u) unlock)
   )
)
(define-fun isLockOrUnlock_lock ((l_u Label)) Bool
   (and
      (exec l_u)
      (= (obj l_u) lock)
   )
)

(define-fun notBetween_lock ((l_1 Label) (l_2 Label) (l_3 Label)) Bool
   (=>
      (= (obj l_3) lock)
      (or
         (/prec_lock l_3 l_1)
         (/prec_lock l_2 l_3)
         (= l_1 l_3)
         (= l_2 l_3)
      )
   )
)

(declare-fun noLockOrUnlockBetween_lock ((Label) (Label)) Bool)
(assert
   (forall ((l_1 Label) (l_2 Label))
      (iff
         (noLockOrUnlockBetween_lock l_1 l_2)
         (and
            (=>
               (exec T2.L)
               (notBetween_lock l_1 l_2 T2.L)
            )
            (=>
               (exec T1.U)
               (notBetween_lock l_1 l_2 T1.U)
            )
            (=>
               (exec T1.L)
               (notBetween_lock l_1 l_2 T1.L)
            )
            (=>
               (exec T2.U)
               (notBetween_lock l_1 l_2 T2.U)
            )
         )
      )
   )
)

(define-fun isLastLockOrUnlockBefore_lock ((l_1 Label)(l_2 Label)) Bool
   (and
      (isLockOrUnlock_lock l_1)
      (isLockOrUnlock_lock l_2)
      (/prec_lock l_1 l_2)
      (noLockOrUnlockBetween_lock l_1 l_2)
   )
)

(assert
   (forall ((l_u Label)(l_l Label))
      (=>
         (and
            (isLock_lock l_l)
            (isLastLockOrUnlockBefore_lock l_u l_l)
         )
         (= (method l_u) unlock) 
      )
   )
)

(assert
   (forall ((l_l Label)(l_u Label))
      (=>
         (and
            (isUnlock_lock l_u)
            (isLastLockOrUnlockBefore_lock l_l l_u)
         )
         (= (method l_l) mlock) 
      )
   )
)
; ----------------------------------------------------------------
(define-fun bug () Bool
   (not
      false
   )
)
(assert bug)
(check-sat)  ; Should print sat

(echo "--------------------------------------")
(eval (exec T1.R1))
(eval (exec T2.W1))
(eval (exec T2.W2))
(eval (exec T1_Inv))
(eval (exec T2_Ret))
(eval (exec T1.C1))
(eval (exec LAST))
(eval (exec T1.W2))
(eval (exec T1.F))
(eval (exec T2.C1))
(eval (exec T1.W1))
(eval (exec T2.R2))
(eval (exec T2.C2))
(eval (exec T2.F))
(eval (exec T2.L))
(eval (exec T1.R2))
(eval (exec T1_Ret))
(eval (exec DR))
(eval (exec T2_Inv))
(eval (exec T1.U))
(eval (exec T1.C2))
(eval (exec T2.R1))
(eval (exec IW1))
(eval (exec IW2))
(eval (exec T1.L))
(eval (exec T2.U))
(echo "--------------------------------------")
(eval (valOf v))
(eval (valOf T2.c4))
(eval (valOf T2.c3))
(eval (valOf T2.c2))
(eval (valOf T2.c1))
(eval (valOf T1.a))
(eval (valOf T2.a))
(eval (valOf T1.c1))
(eval (valOf T1.c2))
(eval (valOf T1.t))
(eval (valOf T1.c3))
(eval (valOf T1.c4))
(eval (valOf T2.t))
(echo "--------------------------------------")
(eval (/prec_X T1.R1 T1.R1))
(eval (/prec_X T1.R1 T2.W1))
(eval (/prec_X T1.R1 T2.W2))
(eval (/prec_X T1.R1 T1_Inv))
(eval (/prec_X T1.R1 T2_Ret))
(eval (/prec_X T1.R1 T1.C1))
(eval (/prec_X T1.R1 LAST))
(eval (/prec_X T1.R1 T1.W2))
(eval (/prec_X T1.R1 T1.F))
(eval (/prec_X T1.R1 T2.C1))
(eval (/prec_X T1.R1 T1.W1))
(eval (/prec_X T1.R1 T2.R2))
(eval (/prec_X T1.R1 T2.C2))
(eval (/prec_X T1.R1 T2.F))
(eval (/prec_X T1.R1 T2.L))
(eval (/prec_X T1.R1 T1.R2))
(eval (/prec_X T1.R1 T1_Ret))
(eval (/prec_X T1.R1 DR))
(eval (/prec_X T1.R1 T2_Inv))
(eval (/prec_X T1.R1 T1.U))
(eval (/prec_X T1.R1 T1.C2))
(eval (/prec_X T1.R1 T2.R1))
(eval (/prec_X T1.R1 IW1))
(eval (/prec_X T1.R1 IW2))
(eval (/prec_X T1.R1 T1.L))
(eval (/prec_X T1.R1 T2.U))
(eval (/prec_X T2.W1 T1.R1))
(eval (/prec_X T2.W1 T2.W1))
(eval (/prec_X T2.W1 T2.W2))
(eval (/prec_X T2.W1 T1_Inv))
(eval (/prec_X T2.W1 T2_Ret))
(eval (/prec_X T2.W1 T1.C1))
(eval (/prec_X T2.W1 LAST))
(eval (/prec_X T2.W1 T1.W2))
(eval (/prec_X T2.W1 T1.F))
(eval (/prec_X T2.W1 T2.C1))
(eval (/prec_X T2.W1 T1.W1))
(eval (/prec_X T2.W1 T2.R2))
(eval (/prec_X T2.W1 T2.C2))
(eval (/prec_X T2.W1 T2.F))
(eval (/prec_X T2.W1 T2.L))
(eval (/prec_X T2.W1 T1.R2))
(eval (/prec_X T2.W1 T1_Ret))
(eval (/prec_X T2.W1 DR))
(eval (/prec_X T2.W1 T2_Inv))
(eval (/prec_X T2.W1 T1.U))
(eval (/prec_X T2.W1 T1.C2))
(eval (/prec_X T2.W1 T2.R1))
(eval (/prec_X T2.W1 IW1))
(eval (/prec_X T2.W1 IW2))
(eval (/prec_X T2.W1 T1.L))
(eval (/prec_X T2.W1 T2.U))
(eval (/prec_X T2.W2 T1.R1))
(eval (/prec_X T2.W2 T2.W1))
(eval (/prec_X T2.W2 T2.W2))
(eval (/prec_X T2.W2 T1_Inv))
(eval (/prec_X T2.W2 T2_Ret))
(eval (/prec_X T2.W2 T1.C1))
(eval (/prec_X T2.W2 LAST))
(eval (/prec_X T2.W2 T1.W2))
(eval (/prec_X T2.W2 T1.F))
(eval (/prec_X T2.W2 T2.C1))
(eval (/prec_X T2.W2 T1.W1))
(eval (/prec_X T2.W2 T2.R2))
(eval (/prec_X T2.W2 T2.C2))
(eval (/prec_X T2.W2 T2.F))
(eval (/prec_X T2.W2 T2.L))
(eval (/prec_X T2.W2 T1.R2))
(eval (/prec_X T2.W2 T1_Ret))
(eval (/prec_X T2.W2 DR))
(eval (/prec_X T2.W2 T2_Inv))
(eval (/prec_X T2.W2 T1.U))
(eval (/prec_X T2.W2 T1.C2))
(eval (/prec_X T2.W2 T2.R1))
(eval (/prec_X T2.W2 IW1))
(eval (/prec_X T2.W2 IW2))
(eval (/prec_X T2.W2 T1.L))
(eval (/prec_X T2.W2 T2.U))
(eval (/prec_X T1_Inv T1.R1))
(eval (/prec_X T1_Inv T2.W1))
(eval (/prec_X T1_Inv T2.W2))
(eval (/prec_X T1_Inv T1_Inv))
(eval (/prec_X T1_Inv T2_Ret))
(eval (/prec_X T1_Inv T1.C1))
(eval (/prec_X T1_Inv LAST))
(eval (/prec_X T1_Inv T1.W2))
(eval (/prec_X T1_Inv T1.F))
(eval (/prec_X T1_Inv T2.C1))
(eval (/prec_X T1_Inv T1.W1))
(eval (/prec_X T1_Inv T2.R2))
(eval (/prec_X T1_Inv T2.C2))
(eval (/prec_X T1_Inv T2.F))
(eval (/prec_X T1_Inv T2.L))
(eval (/prec_X T1_Inv T1.R2))
(eval (/prec_X T1_Inv T1_Ret))
(eval (/prec_X T1_Inv DR))
(eval (/prec_X T1_Inv T2_Inv))
(eval (/prec_X T1_Inv T1.U))
(eval (/prec_X T1_Inv T1.C2))
(eval (/prec_X T1_Inv T2.R1))
(eval (/prec_X T1_Inv IW1))
(eval (/prec_X T1_Inv IW2))
(eval (/prec_X T1_Inv T1.L))
(eval (/prec_X T1_Inv T2.U))
(eval (/prec_X T2_Ret T1.R1))
(eval (/prec_X T2_Ret T2.W1))
(eval (/prec_X T2_Ret T2.W2))
(eval (/prec_X T2_Ret T1_Inv))
(eval (/prec_X T2_Ret T2_Ret))
(eval (/prec_X T2_Ret T1.C1))
(eval (/prec_X T2_Ret LAST))
(eval (/prec_X T2_Ret T1.W2))
(eval (/prec_X T2_Ret T1.F))
(eval (/prec_X T2_Ret T2.C1))
(eval (/prec_X T2_Ret T1.W1))
(eval (/prec_X T2_Ret T2.R2))
(eval (/prec_X T2_Ret T2.C2))
(eval (/prec_X T2_Ret T2.F))
(eval (/prec_X T2_Ret T2.L))
(eval (/prec_X T2_Ret T1.R2))
(eval (/prec_X T2_Ret T1_Ret))
(eval (/prec_X T2_Ret DR))
(eval (/prec_X T2_Ret T2_Inv))
(eval (/prec_X T2_Ret T1.U))
(eval (/prec_X T2_Ret T1.C2))
(eval (/prec_X T2_Ret T2.R1))
(eval (/prec_X T2_Ret IW1))
(eval (/prec_X T2_Ret IW2))
(eval (/prec_X T2_Ret T1.L))
(eval (/prec_X T2_Ret T2.U))
(eval (/prec_X T1.C1 T1.R1))
(eval (/prec_X T1.C1 T2.W1))
(eval (/prec_X T1.C1 T2.W2))
(eval (/prec_X T1.C1 T1_Inv))
(eval (/prec_X T1.C1 T2_Ret))
(eval (/prec_X T1.C1 T1.C1))
(eval (/prec_X T1.C1 LAST))
(eval (/prec_X T1.C1 T1.W2))
(eval (/prec_X T1.C1 T1.F))
(eval (/prec_X T1.C1 T2.C1))
(eval (/prec_X T1.C1 T1.W1))
(eval (/prec_X T1.C1 T2.R2))
(eval (/prec_X T1.C1 T2.C2))
(eval (/prec_X T1.C1 T2.F))
(eval (/prec_X T1.C1 T2.L))
(eval (/prec_X T1.C1 T1.R2))
(eval (/prec_X T1.C1 T1_Ret))
(eval (/prec_X T1.C1 DR))
(eval (/prec_X T1.C1 T2_Inv))
(eval (/prec_X T1.C1 T1.U))
(eval (/prec_X T1.C1 T1.C2))
(eval (/prec_X T1.C1 T2.R1))
(eval (/prec_X T1.C1 IW1))
(eval (/prec_X T1.C1 IW2))
(eval (/prec_X T1.C1 T1.L))
(eval (/prec_X T1.C1 T2.U))
(eval (/prec_X LAST T1.R1))
(eval (/prec_X LAST T2.W1))
(eval (/prec_X LAST T2.W2))
(eval (/prec_X LAST T1_Inv))
(eval (/prec_X LAST T2_Ret))
(eval (/prec_X LAST T1.C1))
(eval (/prec_X LAST LAST))
(eval (/prec_X LAST T1.W2))
(eval (/prec_X LAST T1.F))
(eval (/prec_X LAST T2.C1))
(eval (/prec_X LAST T1.W1))
(eval (/prec_X LAST T2.R2))
(eval (/prec_X LAST T2.C2))
(eval (/prec_X LAST T2.F))
(eval (/prec_X LAST T2.L))
(eval (/prec_X LAST T1.R2))
(eval (/prec_X LAST T1_Ret))
(eval (/prec_X LAST DR))
(eval (/prec_X LAST T2_Inv))
(eval (/prec_X LAST T1.U))
(eval (/prec_X LAST T1.C2))
(eval (/prec_X LAST T2.R1))
(eval (/prec_X LAST IW1))
(eval (/prec_X LAST IW2))
(eval (/prec_X LAST T1.L))
(eval (/prec_X LAST T2.U))
(eval (/prec_X T1.W2 T1.R1))
(eval (/prec_X T1.W2 T2.W1))
(eval (/prec_X T1.W2 T2.W2))
(eval (/prec_X T1.W2 T1_Inv))
(eval (/prec_X T1.W2 T2_Ret))
(eval (/prec_X T1.W2 T1.C1))
(eval (/prec_X T1.W2 LAST))
(eval (/prec_X T1.W2 T1.W2))
(eval (/prec_X T1.W2 T1.F))
(eval (/prec_X T1.W2 T2.C1))
(eval (/prec_X T1.W2 T1.W1))
(eval (/prec_X T1.W2 T2.R2))
(eval (/prec_X T1.W2 T2.C2))
(eval (/prec_X T1.W2 T2.F))
(eval (/prec_X T1.W2 T2.L))
(eval (/prec_X T1.W2 T1.R2))
(eval (/prec_X T1.W2 T1_Ret))
(eval (/prec_X T1.W2 DR))
(eval (/prec_X T1.W2 T2_Inv))
(eval (/prec_X T1.W2 T1.U))
(eval (/prec_X T1.W2 T1.C2))
(eval (/prec_X T1.W2 T2.R1))
(eval (/prec_X T1.W2 IW1))
(eval (/prec_X T1.W2 IW2))
(eval (/prec_X T1.W2 T1.L))
(eval (/prec_X T1.W2 T2.U))
(eval (/prec_X T1.F T1.R1))
(eval (/prec_X T1.F T2.W1))
(eval (/prec_X T1.F T2.W2))
(eval (/prec_X T1.F T1_Inv))
(eval (/prec_X T1.F T2_Ret))
(eval (/prec_X T1.F T1.C1))
(eval (/prec_X T1.F LAST))
(eval (/prec_X T1.F T1.W2))
(eval (/prec_X T1.F T1.F))
(eval (/prec_X T1.F T2.C1))
(eval (/prec_X T1.F T1.W1))
(eval (/prec_X T1.F T2.R2))
(eval (/prec_X T1.F T2.C2))
(eval (/prec_X T1.F T2.F))
(eval (/prec_X T1.F T2.L))
(eval (/prec_X T1.F T1.R2))
(eval (/prec_X T1.F T1_Ret))
(eval (/prec_X T1.F DR))
(eval (/prec_X T1.F T2_Inv))
(eval (/prec_X T1.F T1.U))
(eval (/prec_X T1.F T1.C2))
(eval (/prec_X T1.F T2.R1))
(eval (/prec_X T1.F IW1))
(eval (/prec_X T1.F IW2))
(eval (/prec_X T1.F T1.L))
(eval (/prec_X T1.F T2.U))
(eval (/prec_X T2.C1 T1.R1))
(eval (/prec_X T2.C1 T2.W1))
(eval (/prec_X T2.C1 T2.W2))
(eval (/prec_X T2.C1 T1_Inv))
(eval (/prec_X T2.C1 T2_Ret))
(eval (/prec_X T2.C1 T1.C1))
(eval (/prec_X T2.C1 LAST))
(eval (/prec_X T2.C1 T1.W2))
(eval (/prec_X T2.C1 T1.F))
(eval (/prec_X T2.C1 T2.C1))
(eval (/prec_X T2.C1 T1.W1))
(eval (/prec_X T2.C1 T2.R2))
(eval (/prec_X T2.C1 T2.C2))
(eval (/prec_X T2.C1 T2.F))
(eval (/prec_X T2.C1 T2.L))
(eval (/prec_X T2.C1 T1.R2))
(eval (/prec_X T2.C1 T1_Ret))
(eval (/prec_X T2.C1 DR))
(eval (/prec_X T2.C1 T2_Inv))
(eval (/prec_X T2.C1 T1.U))
(eval (/prec_X T2.C1 T1.C2))
(eval (/prec_X T2.C1 T2.R1))
(eval (/prec_X T2.C1 IW1))
(eval (/prec_X T2.C1 IW2))
(eval (/prec_X T2.C1 T1.L))
(eval (/prec_X T2.C1 T2.U))
(eval (/prec_X T1.W1 T1.R1))
(eval (/prec_X T1.W1 T2.W1))
(eval (/prec_X T1.W1 T2.W2))
(eval (/prec_X T1.W1 T1_Inv))
(eval (/prec_X T1.W1 T2_Ret))
(eval (/prec_X T1.W1 T1.C1))
(eval (/prec_X T1.W1 LAST))
(eval (/prec_X T1.W1 T1.W2))
(eval (/prec_X T1.W1 T1.F))
(eval (/prec_X T1.W1 T2.C1))
(eval (/prec_X T1.W1 T1.W1))
(eval (/prec_X T1.W1 T2.R2))
(eval (/prec_X T1.W1 T2.C2))
(eval (/prec_X T1.W1 T2.F))
(eval (/prec_X T1.W1 T2.L))
(eval (/prec_X T1.W1 T1.R2))
(eval (/prec_X T1.W1 T1_Ret))
(eval (/prec_X T1.W1 DR))
(eval (/prec_X T1.W1 T2_Inv))
(eval (/prec_X T1.W1 T1.U))
(eval (/prec_X T1.W1 T1.C2))
(eval (/prec_X T1.W1 T2.R1))
(eval (/prec_X T1.W1 IW1))
(eval (/prec_X T1.W1 IW2))
(eval (/prec_X T1.W1 T1.L))
(eval (/prec_X T1.W1 T2.U))
(eval (/prec_X T2.R2 T1.R1))
(eval (/prec_X T2.R2 T2.W1))
(eval (/prec_X T2.R2 T2.W2))
(eval (/prec_X T2.R2 T1_Inv))
(eval (/prec_X T2.R2 T2_Ret))
(eval (/prec_X T2.R2 T1.C1))
(eval (/prec_X T2.R2 LAST))
(eval (/prec_X T2.R2 T1.W2))
(eval (/prec_X T2.R2 T1.F))
(eval (/prec_X T2.R2 T2.C1))
(eval (/prec_X T2.R2 T1.W1))
(eval (/prec_X T2.R2 T2.R2))
(eval (/prec_X T2.R2 T2.C2))
(eval (/prec_X T2.R2 T2.F))
(eval (/prec_X T2.R2 T2.L))
(eval (/prec_X T2.R2 T1.R2))
(eval (/prec_X T2.R2 T1_Ret))
(eval (/prec_X T2.R2 DR))
(eval (/prec_X T2.R2 T2_Inv))
(eval (/prec_X T2.R2 T1.U))
(eval (/prec_X T2.R2 T1.C2))
(eval (/prec_X T2.R2 T2.R1))
(eval (/prec_X T2.R2 IW1))
(eval (/prec_X T2.R2 IW2))
(eval (/prec_X T2.R2 T1.L))
(eval (/prec_X T2.R2 T2.U))
(eval (/prec_X T2.C2 T1.R1))
(eval (/prec_X T2.C2 T2.W1))
(eval (/prec_X T2.C2 T2.W2))
(eval (/prec_X T2.C2 T1_Inv))
(eval (/prec_X T2.C2 T2_Ret))
(eval (/prec_X T2.C2 T1.C1))
(eval (/prec_X T2.C2 LAST))
(eval (/prec_X T2.C2 T1.W2))
(eval (/prec_X T2.C2 T1.F))
(eval (/prec_X T2.C2 T2.C1))
(eval (/prec_X T2.C2 T1.W1))
(eval (/prec_X T2.C2 T2.R2))
(eval (/prec_X T2.C2 T2.C2))
(eval (/prec_X T2.C2 T2.F))
(eval (/prec_X T2.C2 T2.L))
(eval (/prec_X T2.C2 T1.R2))
(eval (/prec_X T2.C2 T1_Ret))
(eval (/prec_X T2.C2 DR))
(eval (/prec_X T2.C2 T2_Inv))
(eval (/prec_X T2.C2 T1.U))
(eval (/prec_X T2.C2 T1.C2))
(eval (/prec_X T2.C2 T2.R1))
(eval (/prec_X T2.C2 IW1))
(eval (/prec_X T2.C2 IW2))
(eval (/prec_X T2.C2 T1.L))
(eval (/prec_X T2.C2 T2.U))
(eval (/prec_X T2.F T1.R1))
(eval (/prec_X T2.F T2.W1))
(eval (/prec_X T2.F T2.W2))
(eval (/prec_X T2.F T1_Inv))
(eval (/prec_X T2.F T2_Ret))
(eval (/prec_X T2.F T1.C1))
(eval (/prec_X T2.F LAST))
(eval (/prec_X T2.F T1.W2))
(eval (/prec_X T2.F T1.F))
(eval (/prec_X T2.F T2.C1))
(eval (/prec_X T2.F T1.W1))
(eval (/prec_X T2.F T2.R2))
(eval (/prec_X T2.F T2.C2))
(eval (/prec_X T2.F T2.F))
(eval (/prec_X T2.F T2.L))
(eval (/prec_X T2.F T1.R2))
(eval (/prec_X T2.F T1_Ret))
(eval (/prec_X T2.F DR))
(eval (/prec_X T2.F T2_Inv))
(eval (/prec_X T2.F T1.U))
(eval (/prec_X T2.F T1.C2))
(eval (/prec_X T2.F T2.R1))
(eval (/prec_X T2.F IW1))
(eval (/prec_X T2.F IW2))
(eval (/prec_X T2.F T1.L))
(eval (/prec_X T2.F T2.U))
(eval (/prec_X T2.L T1.R1))
(eval (/prec_X T2.L T2.W1))
(eval (/prec_X T2.L T2.W2))
(eval (/prec_X T2.L T1_Inv))
(eval (/prec_X T2.L T2_Ret))
(eval (/prec_X T2.L T1.C1))
(eval (/prec_X T2.L LAST))
(eval (/prec_X T2.L T1.W2))
(eval (/prec_X T2.L T1.F))
(eval (/prec_X T2.L T2.C1))
(eval (/prec_X T2.L T1.W1))
(eval (/prec_X T2.L T2.R2))
(eval (/prec_X T2.L T2.C2))
(eval (/prec_X T2.L T2.F))
(eval (/prec_X T2.L T2.L))
(eval (/prec_X T2.L T1.R2))
(eval (/prec_X T2.L T1_Ret))
(eval (/prec_X T2.L DR))
(eval (/prec_X T2.L T2_Inv))
(eval (/prec_X T2.L T1.U))
(eval (/prec_X T2.L T1.C2))
(eval (/prec_X T2.L T2.R1))
(eval (/prec_X T2.L IW1))
(eval (/prec_X T2.L IW2))
(eval (/prec_X T2.L T1.L))
(eval (/prec_X T2.L T2.U))
(eval (/prec_X T1.R2 T1.R1))
(eval (/prec_X T1.R2 T2.W1))
(eval (/prec_X T1.R2 T2.W2))
(eval (/prec_X T1.R2 T1_Inv))
(eval (/prec_X T1.R2 T2_Ret))
(eval (/prec_X T1.R2 T1.C1))
(eval (/prec_X T1.R2 LAST))
(eval (/prec_X T1.R2 T1.W2))
(eval (/prec_X T1.R2 T1.F))
(eval (/prec_X T1.R2 T2.C1))
(eval (/prec_X T1.R2 T1.W1))
(eval (/prec_X T1.R2 T2.R2))
(eval (/prec_X T1.R2 T2.C2))
(eval (/prec_X T1.R2 T2.F))
(eval (/prec_X T1.R2 T2.L))
(eval (/prec_X T1.R2 T1.R2))
(eval (/prec_X T1.R2 T1_Ret))
(eval (/prec_X T1.R2 DR))
(eval (/prec_X T1.R2 T2_Inv))
(eval (/prec_X T1.R2 T1.U))
(eval (/prec_X T1.R2 T1.C2))
(eval (/prec_X T1.R2 T2.R1))
(eval (/prec_X T1.R2 IW1))
(eval (/prec_X T1.R2 IW2))
(eval (/prec_X T1.R2 T1.L))
(eval (/prec_X T1.R2 T2.U))
(eval (/prec_X T1_Ret T1.R1))
(eval (/prec_X T1_Ret T2.W1))
(eval (/prec_X T1_Ret T2.W2))
(eval (/prec_X T1_Ret T1_Inv))
(eval (/prec_X T1_Ret T2_Ret))
(eval (/prec_X T1_Ret T1.C1))
(eval (/prec_X T1_Ret LAST))
(eval (/prec_X T1_Ret T1.W2))
(eval (/prec_X T1_Ret T1.F))
(eval (/prec_X T1_Ret T2.C1))
(eval (/prec_X T1_Ret T1.W1))
(eval (/prec_X T1_Ret T2.R2))
(eval (/prec_X T1_Ret T2.C2))
(eval (/prec_X T1_Ret T2.F))
(eval (/prec_X T1_Ret T2.L))
(eval (/prec_X T1_Ret T1.R2))
(eval (/prec_X T1_Ret T1_Ret))
(eval (/prec_X T1_Ret DR))
(eval (/prec_X T1_Ret T2_Inv))
(eval (/prec_X T1_Ret T1.U))
(eval (/prec_X T1_Ret T1.C2))
(eval (/prec_X T1_Ret T2.R1))
(eval (/prec_X T1_Ret IW1))
(eval (/prec_X T1_Ret IW2))
(eval (/prec_X T1_Ret T1.L))
(eval (/prec_X T1_Ret T2.U))
(eval (/prec_X DR T1.R1))
(eval (/prec_X DR T2.W1))
(eval (/prec_X DR T2.W2))
(eval (/prec_X DR T1_Inv))
(eval (/prec_X DR T2_Ret))
(eval (/prec_X DR T1.C1))
(eval (/prec_X DR LAST))
(eval (/prec_X DR T1.W2))
(eval (/prec_X DR T1.F))
(eval (/prec_X DR T2.C1))
(eval (/prec_X DR T1.W1))
(eval (/prec_X DR T2.R2))
(eval (/prec_X DR T2.C2))
(eval (/prec_X DR T2.F))
(eval (/prec_X DR T2.L))
(eval (/prec_X DR T1.R2))
(eval (/prec_X DR T1_Ret))
(eval (/prec_X DR DR))
(eval (/prec_X DR T2_Inv))
(eval (/prec_X DR T1.U))
(eval (/prec_X DR T1.C2))
(eval (/prec_X DR T2.R1))
(eval (/prec_X DR IW1))
(eval (/prec_X DR IW2))
(eval (/prec_X DR T1.L))
(eval (/prec_X DR T2.U))
(eval (/prec_X T2_Inv T1.R1))
(eval (/prec_X T2_Inv T2.W1))
(eval (/prec_X T2_Inv T2.W2))
(eval (/prec_X T2_Inv T1_Inv))
(eval (/prec_X T2_Inv T2_Ret))
(eval (/prec_X T2_Inv T1.C1))
(eval (/prec_X T2_Inv LAST))
(eval (/prec_X T2_Inv T1.W2))
(eval (/prec_X T2_Inv T1.F))
(eval (/prec_X T2_Inv T2.C1))
(eval (/prec_X T2_Inv T1.W1))
(eval (/prec_X T2_Inv T2.R2))
(eval (/prec_X T2_Inv T2.C2))
(eval (/prec_X T2_Inv T2.F))
(eval (/prec_X T2_Inv T2.L))
(eval (/prec_X T2_Inv T1.R2))
(eval (/prec_X T2_Inv T1_Ret))
(eval (/prec_X T2_Inv DR))
(eval (/prec_X T2_Inv T2_Inv))
(eval (/prec_X T2_Inv T1.U))
(eval (/prec_X T2_Inv T1.C2))
(eval (/prec_X T2_Inv T2.R1))
(eval (/prec_X T2_Inv IW1))
(eval (/prec_X T2_Inv IW2))
(eval (/prec_X T2_Inv T1.L))
(eval (/prec_X T2_Inv T2.U))
(eval (/prec_X T1.U T1.R1))
(eval (/prec_X T1.U T2.W1))
(eval (/prec_X T1.U T2.W2))
(eval (/prec_X T1.U T1_Inv))
(eval (/prec_X T1.U T2_Ret))
(eval (/prec_X T1.U T1.C1))
(eval (/prec_X T1.U LAST))
(eval (/prec_X T1.U T1.W2))
(eval (/prec_X T1.U T1.F))
(eval (/prec_X T1.U T2.C1))
(eval (/prec_X T1.U T1.W1))
(eval (/prec_X T1.U T2.R2))
(eval (/prec_X T1.U T2.C2))
(eval (/prec_X T1.U T2.F))
(eval (/prec_X T1.U T2.L))
(eval (/prec_X T1.U T1.R2))
(eval (/prec_X T1.U T1_Ret))
(eval (/prec_X T1.U DR))
(eval (/prec_X T1.U T2_Inv))
(eval (/prec_X T1.U T1.U))
(eval (/prec_X T1.U T1.C2))
(eval (/prec_X T1.U T2.R1))
(eval (/prec_X T1.U IW1))
(eval (/prec_X T1.U IW2))
(eval (/prec_X T1.U T1.L))
(eval (/prec_X T1.U T2.U))
(eval (/prec_X T1.C2 T1.R1))
(eval (/prec_X T1.C2 T2.W1))
(eval (/prec_X T1.C2 T2.W2))
(eval (/prec_X T1.C2 T1_Inv))
(eval (/prec_X T1.C2 T2_Ret))
(eval (/prec_X T1.C2 T1.C1))
(eval (/prec_X T1.C2 LAST))
(eval (/prec_X T1.C2 T1.W2))
(eval (/prec_X T1.C2 T1.F))
(eval (/prec_X T1.C2 T2.C1))
(eval (/prec_X T1.C2 T1.W1))
(eval (/prec_X T1.C2 T2.R2))
(eval (/prec_X T1.C2 T2.C2))
(eval (/prec_X T1.C2 T2.F))
(eval (/prec_X T1.C2 T2.L))
(eval (/prec_X T1.C2 T1.R2))
(eval (/prec_X T1.C2 T1_Ret))
(eval (/prec_X T1.C2 DR))
(eval (/prec_X T1.C2 T2_Inv))
(eval (/prec_X T1.C2 T1.U))
(eval (/prec_X T1.C2 T1.C2))
(eval (/prec_X T1.C2 T2.R1))
(eval (/prec_X T1.C2 IW1))
(eval (/prec_X T1.C2 IW2))
(eval (/prec_X T1.C2 T1.L))
(eval (/prec_X T1.C2 T2.U))
(eval (/prec_X T2.R1 T1.R1))
(eval (/prec_X T2.R1 T2.W1))
(eval (/prec_X T2.R1 T2.W2))
(eval (/prec_X T2.R1 T1_Inv))
(eval (/prec_X T2.R1 T2_Ret))
(eval (/prec_X T2.R1 T1.C1))
(eval (/prec_X T2.R1 LAST))
(eval (/prec_X T2.R1 T1.W2))
(eval (/prec_X T2.R1 T1.F))
(eval (/prec_X T2.R1 T2.C1))
(eval (/prec_X T2.R1 T1.W1))
(eval (/prec_X T2.R1 T2.R2))
(eval (/prec_X T2.R1 T2.C2))
(eval (/prec_X T2.R1 T2.F))
(eval (/prec_X T2.R1 T2.L))
(eval (/prec_X T2.R1 T1.R2))
(eval (/prec_X T2.R1 T1_Ret))
(eval (/prec_X T2.R1 DR))
(eval (/prec_X T2.R1 T2_Inv))
(eval (/prec_X T2.R1 T1.U))
(eval (/prec_X T2.R1 T1.C2))
(eval (/prec_X T2.R1 T2.R1))
(eval (/prec_X T2.R1 IW1))
(eval (/prec_X T2.R1 IW2))
(eval (/prec_X T2.R1 T1.L))
(eval (/prec_X T2.R1 T2.U))
(eval (/prec_X IW1 T1.R1))
(eval (/prec_X IW1 T2.W1))
(eval (/prec_X IW1 T2.W2))
(eval (/prec_X IW1 T1_Inv))
(eval (/prec_X IW1 T2_Ret))
(eval (/prec_X IW1 T1.C1))
(eval (/prec_X IW1 LAST))
(eval (/prec_X IW1 T1.W2))
(eval (/prec_X IW1 T1.F))
(eval (/prec_X IW1 T2.C1))
(eval (/prec_X IW1 T1.W1))
(eval (/prec_X IW1 T2.R2))
(eval (/prec_X IW1 T2.C2))
(eval (/prec_X IW1 T2.F))
(eval (/prec_X IW1 T2.L))
(eval (/prec_X IW1 T1.R2))
(eval (/prec_X IW1 T1_Ret))
(eval (/prec_X IW1 DR))
(eval (/prec_X IW1 T2_Inv))
(eval (/prec_X IW1 T1.U))
(eval (/prec_X IW1 T1.C2))
(eval (/prec_X IW1 T2.R1))
(eval (/prec_X IW1 IW1))
(eval (/prec_X IW1 IW2))
(eval (/prec_X IW1 T1.L))
(eval (/prec_X IW1 T2.U))
(eval (/prec_X IW2 T1.R1))
(eval (/prec_X IW2 T2.W1))
(eval (/prec_X IW2 T2.W2))
(eval (/prec_X IW2 T1_Inv))
(eval (/prec_X IW2 T2_Ret))
(eval (/prec_X IW2 T1.C1))
(eval (/prec_X IW2 LAST))
(eval (/prec_X IW2 T1.W2))
(eval (/prec_X IW2 T1.F))
(eval (/prec_X IW2 T2.C1))
(eval (/prec_X IW2 T1.W1))
(eval (/prec_X IW2 T2.R2))
(eval (/prec_X IW2 T2.C2))
(eval (/prec_X IW2 T2.F))
(eval (/prec_X IW2 T2.L))
(eval (/prec_X IW2 T1.R2))
(eval (/prec_X IW2 T1_Ret))
(eval (/prec_X IW2 DR))
(eval (/prec_X IW2 T2_Inv))
(eval (/prec_X IW2 T1.U))
(eval (/prec_X IW2 T1.C2))
(eval (/prec_X IW2 T2.R1))
(eval (/prec_X IW2 IW1))
(eval (/prec_X IW2 IW2))
(eval (/prec_X IW2 T1.L))
(eval (/prec_X IW2 T2.U))
(eval (/prec_X T1.L T1.R1))
(eval (/prec_X T1.L T2.W1))
(eval (/prec_X T1.L T2.W2))
(eval (/prec_X T1.L T1_Inv))
(eval (/prec_X T1.L T2_Ret))
(eval (/prec_X T1.L T1.C1))
(eval (/prec_X T1.L LAST))
(eval (/prec_X T1.L T1.W2))
(eval (/prec_X T1.L T1.F))
(eval (/prec_X T1.L T2.C1))
(eval (/prec_X T1.L T1.W1))
(eval (/prec_X T1.L T2.R2))
(eval (/prec_X T1.L T2.C2))
(eval (/prec_X T1.L T2.F))
(eval (/prec_X T1.L T2.L))
(eval (/prec_X T1.L T1.R2))
(eval (/prec_X T1.L T1_Ret))
(eval (/prec_X T1.L DR))
(eval (/prec_X T1.L T2_Inv))
(eval (/prec_X T1.L T1.U))
(eval (/prec_X T1.L T1.C2))
(eval (/prec_X T1.L T2.R1))
(eval (/prec_X T1.L IW1))
(eval (/prec_X T1.L IW2))
(eval (/prec_X T1.L T1.L))
(eval (/prec_X T1.L T2.U))
(eval (/prec_X T2.U T1.R1))
(eval (/prec_X T2.U T2.W1))
(eval (/prec_X T2.U T2.W2))
(eval (/prec_X T2.U T1_Inv))
(eval (/prec_X T2.U T2_Ret))
(eval (/prec_X T2.U T1.C1))
(eval (/prec_X T2.U LAST))
(eval (/prec_X T2.U T1.W2))
(eval (/prec_X T2.U T1.F))
(eval (/prec_X T2.U T2.C1))
(eval (/prec_X T2.U T1.W1))
(eval (/prec_X T2.U T2.R2))
(eval (/prec_X T2.U T2.C2))
(eval (/prec_X T2.U T2.F))
(eval (/prec_X T2.U T2.L))
(eval (/prec_X T2.U T1.R2))
(eval (/prec_X T2.U T1_Ret))
(eval (/prec_X T2.U DR))
(eval (/prec_X T2.U T2_Inv))
(eval (/prec_X T2.U T1.U))
(eval (/prec_X T2.U T1.C2))
(eval (/prec_X T2.U T2.R1))
(eval (/prec_X T2.U IW1))
(eval (/prec_X T2.U IW2))
(eval (/prec_X T2.U T1.L))
(eval (/prec_X T2.U T2.U))
(echo "--------------------------------------")
