; --------------------------------------------------------------
; Settings
;(set-option :mbqi true)
(set-option :macro-finder true)
(set-option :pull-nested-quantifiers true)
;(set-option :produce-unsat-cores true)
; --------------------------------------------------------------

(declare-datatypes () (
   (Obj
      (l)
      (reg)
      lastObj
      thisEvObj
      returnObj
      noObj
   )
))

(declare-datatypes () (
   (Name
      mtryLock
      cas
      unlock
      write
      read
      mlock
      this
   )
))

(declare-datatypes () (
   (Label
      L2_1_Ret L2_0 L1_1_Ret L0_1_Ret L1_0 L0_1_Inv L2_1_Inv LAST L2_2 L3_2 L3_0 L1_1_Inv L1_2 L3_1_Inv L3_1_Ret 
   )
))

(declare-datatypes () (
   (Var
      v
   )
))

(declare-datatypes () (
   (Varl
      (var (unvar Var))
      (val (unval Int))
   )
))

(declare-fun valOf (Var) Int)

(declare-fun obj (Label) Obj)
(declare-fun method (Label) Name)
(declare-fun arg1 (Label) Varl)
(declare-fun arg2 (Label) Varl)
(declare-fun retv (Label) Var)
(declare-fun retEv (Label) Label)

(define-fun valOfVarl ((v Varl)) Int
   (ite
      (is-var v)
      (valOf (unvar v))
      (unval v)
   )
)
(define-fun validEq ((v1 Varl)(v2 Varl)) Bool
   (= (valOfVarl v1) (valOfVarl v2))
)


(declare-fun exec (Label) Bool)
(declare-fun /prec_p (Label Label) Bool)
(declare-fun /prec_X (Label Label) Bool)
(assert (exec LAST))
; ----------------------------------------------------------------
(assert
   (and
      (= (obj L2_1_Ret) noObj)
      (or
         (/prec_X L2_2 L2_1_Inv)
         (/prec_X L2_1_Ret L2_2)
      )
      (or
         (/prec_X L2_0 L2_1_Inv)
         (/prec_X L2_1_Ret L2_0)
      )
   )
)

(assert
   (and
      (= (obj L2_0) l)
      (= (method L2_0) mlock)
   )
)

(assert
   (and
      (= (obj L1_1_Ret) noObj)
      (or
         (/prec_X L1_2 L1_1_Inv)
         (/prec_X L1_1_Ret L1_2)
      )
      (or
         (/prec_X L1_0 L1_1_Inv)
         (/prec_X L1_1_Ret L1_0)
      )
   )
)

(assert
   (and
      (= (obj L0_1_Ret) noObj)
   )
)

(assert
   (and
      (= (obj L1_0) l)
      (= (method L1_0) mlock)
   )
)

(assert
   (and
      (= (obj L0_1_Inv) reg)
      (= (method L0_1_Inv) write)
      (= (arg1 L0_1_Inv) (val 0))
      (= (retEv L0_1_Inv) L0_1_Ret)
   )
)

(assert
   (and
      (= (obj L2_1_Inv) reg)
      (= (method L2_1_Inv) write)
      (= (arg1 L2_1_Inv) (val 8))
      (= (retEv L2_1_Inv) L2_1_Ret)
   )
)

(assert
   (and
      (= (obj LAST) lastObj)
      (= (method LAST) read)
   )
)

(assert
   (and
      (= (obj L2_2) l)
      (= (method L2_2) unlock)
   )
)

(assert
   (and
      (= (obj L3_2) l)
      (= (method L3_2) unlock)
   )
)

(assert
   (and
      (= (obj L3_0) l)
      (= (method L3_0) mlock)
   )
)

(assert
   (and
      (= (obj L1_1_Inv) reg)
      (= (method L1_1_Inv) write)
      (= (arg1 L1_1_Inv) (val 7))
      (= (retEv L1_1_Inv) L1_1_Ret)
   )
)

(assert
   (and
      (= (obj L1_2) l)
      (= (method L1_2) unlock)
   )
)

(assert
   (and
      (= (obj L3_1_Inv) reg)
      (= (method L3_1_Inv) read)
      (= (retv L3_1_Inv) v)
      (= (retEv L3_1_Inv) L3_1_Ret)
   )
)

(assert
   (and
      (= (obj L3_1_Ret) noObj)
      (or
         (/prec_X L3_2 L3_1_Inv)
         (/prec_X L3_1_Ret L3_2)
      )
      (or
         (/prec_X L3_0 L3_1_Inv)
         (/prec_X L3_1_Ret L3_0)
      )
   )
)

(assert
   (exec L2_1_Ret)
)

(assert
   (exec L2_0)
)

(assert
   (exec L1_1_Ret)
)

(assert
   (exec L0_1_Ret)
)

(assert
   (exec L1_0)
)

(assert
   (exec L0_1_Inv)
)

(assert
   (exec L2_1_Inv)
)

(assert
   (exec LAST)
)

(assert
   (exec L2_2)
)

(assert
   (exec L3_2)
)

(assert
   (exec L3_0)
)

(assert
   (exec L1_1_Inv)
)

(assert
   (exec L1_2)
)

(assert
   (exec L3_1_Inv)
)

(assert
   (exec L3_1_Ret)
)

(assert
   (and
      (/prec_p L2_1_Ret LAST)
      (/prec_p L2_1_Ret L2_2)
      (/prec_p L2_0 LAST)
      (/prec_p L2_0 L2_2)
      (/prec_p L2_0 L2_1_Ret)
      (/prec_p L2_0 L2_1_Inv)
      (/prec_p L1_1_Ret LAST)
      (/prec_p L1_1_Ret L1_2)
      (/prec_p L0_1_Ret L2_1_Ret)
      (/prec_p L0_1_Ret L2_0)
      (/prec_p L0_1_Ret L1_1_Ret)
      (/prec_p L0_1_Ret L1_0)
      (/prec_p L0_1_Ret L2_1_Inv)
      (/prec_p L0_1_Ret LAST)
      (/prec_p L0_1_Ret L2_2)
      (/prec_p L0_1_Ret L3_2)
      (/prec_p L0_1_Ret L3_0)
      (/prec_p L0_1_Ret L1_1_Inv)
      (/prec_p L0_1_Ret L1_2)
      (/prec_p L0_1_Ret L3_1_Inv)
      (/prec_p L0_1_Ret L3_1_Ret)
      (/prec_p L1_0 LAST)
      (/prec_p L1_0 L1_1_Inv)
      (/prec_p L1_0 L1_2)
      (/prec_p L1_0 L1_1_Ret)
      (/prec_p L0_1_Inv L2_1_Ret)
      (/prec_p L0_1_Inv L2_0)
      (/prec_p L0_1_Inv L1_1_Ret)
      (/prec_p L0_1_Inv L0_1_Ret)
      (/prec_p L0_1_Inv L1_0)
      (/prec_p L0_1_Inv L2_1_Inv)
      (/prec_p L0_1_Inv LAST)
      (/prec_p L0_1_Inv L2_2)
      (/prec_p L0_1_Inv L3_2)
      (/prec_p L0_1_Inv L3_0)
      (/prec_p L0_1_Inv L1_1_Inv)
      (/prec_p L0_1_Inv L1_2)
      (/prec_p L0_1_Inv L3_1_Inv)
      (/prec_p L0_1_Inv L3_1_Ret)
      (/prec_p L2_1_Inv LAST)
      (/prec_p L2_1_Inv L2_2)
      (/prec_p L2_1_Inv L2_1_Ret)
      (/prec_p L2_2 LAST)
      (/prec_p L3_2 LAST)
      (/prec_p L3_0 LAST)
      (/prec_p L3_0 L3_2)
      (/prec_p L3_0 L3_1_Inv)
      (/prec_p L3_0 L3_1_Ret)
      (/prec_p L1_1_Inv LAST)
      (/prec_p L1_1_Inv L1_2)
      (/prec_p L1_1_Inv L1_1_Ret)
      (/prec_p L1_2 LAST)
      (/prec_p L3_1_Inv LAST)
      (/prec_p L3_1_Inv L3_2)
      (/prec_p L3_1_Inv L3_1_Ret)
      (/prec_p L3_1_Ret LAST)
      (/prec_p L3_1_Ret L3_2)
   )
)
; ----------------------------------------------------------------
; ----------------------------------------------------------------
; ----------------------------------------------------------------
; --------------------------------------------------------------
; /prec_X

; P2X
(assert
   (forall ((l1 Label) (l2 Label))
      (=> 
         (and
            (/prec_p l1 l2)
            (exec l1)
            (exec l2)
         )
         (/prec_X l1 l2)
      )
   )
)

; Total
(assert
   (forall ((l_1 Label) (l_2 Label))
      (=>
         (and
            (not (= l_1 l_2))
            (exec l_1)
            (exec l_2)
         )
         (or 
            (/prec_X l_1 l_2)
            (/prec_X l_2 l_1)
         )
      )
   )
)

; Transitive
(assert
   (forall ((l1 Label) (l2 Label) (l3 Label))
      (=>
         (and
            (/prec_X l1 l2)
            (/prec_X l2 l3)
         )
         (/prec_X l1 l3)
      )
   )
)

; Asymmetric
(assert
   (forall ((l1 Label) (l2 Label))
      (not
         (and 
            (/prec_X l1 l2)
            (/prec_X l2 l1)
         )
      )
   )
)

; --------------------------------------------------------------
; ----------------------------------------------------------------
(declare-fun /prec_l ((Label) (Label)) Bool)

(assert
   (forall ((l_1 Label) (l_2 Label))
      (=>
         (and
            (= (obj l_1) l)
            (= (obj l_2) l)
         )
         (iff
            (/prec_X l_1 l_2)
            (/prec_l l_1 l_2)
         )
      )
   )
)
; ----------------------------------------------------------------
; ----------------------------------------------------------------
(define-fun isLock_l ((l_l Label)) Bool
   (and
      (exec l_l)
      (= (obj l_l) l)
      (= (method l_l) mlock)
   )
)
(define-fun isUnlock_l ((l_u Label)) Bool
   (and
      (exec l_u)
      (= (obj l_u) l)
      (= (method l_u) unlock)
   )
)
(define-fun isLockOrUnlock_l ((l_u Label)) Bool
   (and
      (exec l_u)
      (= (obj l_u) l)
   )
)

(define-fun notBetween_l ((l_1 Label) (l_2 Label) (l_3 Label)) Bool
   (=>
      (= (obj l_3) l)
      (or
         (/prec_l l_3 l_1)
         (/prec_l l_2 l_3)
         (= l_1 l_3)
         (= l_2 l_3)
      )
   )
)

(declare-fun noLockOrUnlockBetween_l ((Label) (Label)) Bool)
(assert
   (forall ((l_1 Label) (l_2 Label))
      (iff
         (noLockOrUnlockBetween_l l_1 l_2)
         (and
            (=>
               (exec L2_0)
               (notBetween_l l_1 l_2 L2_0)
            )
            (=>
               (exec L1_0)
               (notBetween_l l_1 l_2 L1_0)
            )
            (=>
               (exec L2_2)
               (notBetween_l l_1 l_2 L2_2)
            )
            (=>
               (exec L3_2)
               (notBetween_l l_1 l_2 L3_2)
            )
            (=>
               (exec L3_0)
               (notBetween_l l_1 l_2 L3_0)
            )
            (=>
               (exec L1_2)
               (notBetween_l l_1 l_2 L1_2)
            )
         )
      )
   )
)

(define-fun isLastLockOrUnlockBefore_l ((l_1 Label)(l_2 Label)) Bool
   (and
      (isLockOrUnlock_l l_1)
      (isLockOrUnlock_l l_2)
      (/prec_l l_1 l_2)
      (noLockOrUnlockBetween_l l_1 l_2)
   )
)

(assert
   (forall ((l_u Label)(l_l Label))
      (=>
         (and
            (isLock_l l_l)
            (isLastLockOrUnlockBefore_l l_u l_l)
         )
         (= (method l_u) unlock) 
      )
   )
)

(assert
   (forall ((l_l Label)(l_u Label))
      (=>
         (and
            (isUnlock_l l_u)
            (isLastLockOrUnlockBefore_l l_l l_u)
         )
         (= (method l_l) mlock) 
      )
   )
)
; ----------------------------------------------------------------
; ----------------------------------------------------------------

(define-fun isSeq_reg () Bool
   (forall ((l1 Label) (l2 Label))
      (=>
         (and
            (= (obj l1) reg)
            (= (obj l2) reg)
         )
         (or
            (= l1 l2)
            (/prec_X (retEv l1) l2)
            (/prec_X (retEv l2) l1)
         )
      )
   )
)

(define-fun isRead_X_reg ((l_r Label)) Bool
   (and
      (exec l_r)
      (= (obj l_r) reg)
      (= (method l_r) read)
   )
)
(define-fun isWrite_X_reg ((l_w Label)) Bool
   (and
      (exec l_w)
      (= (obj l_w) reg)
      (= (method l_w) write)
   )
)

(define-fun noWriteBetween_X_reg_p ((l_w Label) (l_r Label) (l_w^ Label)) Bool
   (=>
      (isWrite_X_reg l_w^)
      (or
         (/prec_X l_w^ l_w)
         (/prec_X l_r l_w^)
         (= l_w l_w^)
      )
   )
)

(declare-fun noWriteBetween_X_reg ((Label) (Label)) Bool)
(assert
   (forall ((l_w Label) (l_r Label))
      (iff
         (noWriteBetween_X_reg l_w l_r)
         (and
            (noWriteBetween_X_reg_p l_w l_r L0_1_Inv)
            (noWriteBetween_X_reg_p l_w l_r L2_1_Inv)
            (noWriteBetween_X_reg_p l_w l_r L1_1_Inv)
            (noWriteBetween_X_reg_p l_w l_r L3_1_Inv)
         )
      )
   )
)


(define-fun isWriter_X_reg ((l_w Label)(l_r Label)) Bool
   (and
      (isWrite_X_reg l_w)
      (/prec_X l_w l_r)
      (noWriteBetween_X_reg l_w l_r)
   )
)

(assert
   (forall ((l_r Label)(l_w Label))
      (=>
         (and
            isSeq_reg
            (isRead_X_reg l_r)
            (isWriter_X_reg l_w l_r)
         )
         (validEq (var (retv l_r)) (arg1 l_w))
      )
   )
)

; ----------------------------------------------------------------
(define-fun bug () Bool
   (not
      (or (or (= (valOf v) 0) (= (valOf v) 7)) (= (valOf v) 8))
   )
)
(assert bug)
(check-sat)  ; Should print sat

(echo "--------------------------------------")
(eval (exec L2_1_Ret))
(eval (exec L2_0))
(eval (exec L1_1_Ret))
(eval (exec L0_1_Ret))
(eval (exec L1_0))
(eval (exec L0_1_Inv))
(eval (exec L2_1_Inv))
(eval (exec LAST))
(eval (exec L2_2))
(eval (exec L3_2))
(eval (exec L3_0))
(eval (exec L1_1_Inv))
(eval (exec L1_2))
(eval (exec L3_1_Inv))
(eval (exec L3_1_Ret))
(echo "--------------------------------------")
(eval (valOf v))
(echo "--------------------------------------")
(eval (/prec_X L2_1_Ret L2_1_Ret))
(eval (/prec_X L2_1_Ret L2_0))
(eval (/prec_X L2_1_Ret L1_1_Ret))
(eval (/prec_X L2_1_Ret L0_1_Ret))
(eval (/prec_X L2_1_Ret L1_0))
(eval (/prec_X L2_1_Ret L0_1_Inv))
(eval (/prec_X L2_1_Ret L2_1_Inv))
(eval (/prec_X L2_1_Ret LAST))
(eval (/prec_X L2_1_Ret L2_2))
(eval (/prec_X L2_1_Ret L3_2))
(eval (/prec_X L2_1_Ret L3_0))
(eval (/prec_X L2_1_Ret L1_1_Inv))
(eval (/prec_X L2_1_Ret L1_2))
(eval (/prec_X L2_1_Ret L3_1_Inv))
(eval (/prec_X L2_1_Ret L3_1_Ret))
(eval (/prec_X L2_0 L2_1_Ret))
(eval (/prec_X L2_0 L2_0))
(eval (/prec_X L2_0 L1_1_Ret))
(eval (/prec_X L2_0 L0_1_Ret))
(eval (/prec_X L2_0 L1_0))
(eval (/prec_X L2_0 L0_1_Inv))
(eval (/prec_X L2_0 L2_1_Inv))
(eval (/prec_X L2_0 LAST))
(eval (/prec_X L2_0 L2_2))
(eval (/prec_X L2_0 L3_2))
(eval (/prec_X L2_0 L3_0))
(eval (/prec_X L2_0 L1_1_Inv))
(eval (/prec_X L2_0 L1_2))
(eval (/prec_X L2_0 L3_1_Inv))
(eval (/prec_X L2_0 L3_1_Ret))
(eval (/prec_X L1_1_Ret L2_1_Ret))
(eval (/prec_X L1_1_Ret L2_0))
(eval (/prec_X L1_1_Ret L1_1_Ret))
(eval (/prec_X L1_1_Ret L0_1_Ret))
(eval (/prec_X L1_1_Ret L1_0))
(eval (/prec_X L1_1_Ret L0_1_Inv))
(eval (/prec_X L1_1_Ret L2_1_Inv))
(eval (/prec_X L1_1_Ret LAST))
(eval (/prec_X L1_1_Ret L2_2))
(eval (/prec_X L1_1_Ret L3_2))
(eval (/prec_X L1_1_Ret L3_0))
(eval (/prec_X L1_1_Ret L1_1_Inv))
(eval (/prec_X L1_1_Ret L1_2))
(eval (/prec_X L1_1_Ret L3_1_Inv))
(eval (/prec_X L1_1_Ret L3_1_Ret))
(eval (/prec_X L0_1_Ret L2_1_Ret))
(eval (/prec_X L0_1_Ret L2_0))
(eval (/prec_X L0_1_Ret L1_1_Ret))
(eval (/prec_X L0_1_Ret L0_1_Ret))
(eval (/prec_X L0_1_Ret L1_0))
(eval (/prec_X L0_1_Ret L0_1_Inv))
(eval (/prec_X L0_1_Ret L2_1_Inv))
(eval (/prec_X L0_1_Ret LAST))
(eval (/prec_X L0_1_Ret L2_2))
(eval (/prec_X L0_1_Ret L3_2))
(eval (/prec_X L0_1_Ret L3_0))
(eval (/prec_X L0_1_Ret L1_1_Inv))
(eval (/prec_X L0_1_Ret L1_2))
(eval (/prec_X L0_1_Ret L3_1_Inv))
(eval (/prec_X L0_1_Ret L3_1_Ret))
(eval (/prec_X L1_0 L2_1_Ret))
(eval (/prec_X L1_0 L2_0))
(eval (/prec_X L1_0 L1_1_Ret))
(eval (/prec_X L1_0 L0_1_Ret))
(eval (/prec_X L1_0 L1_0))
(eval (/prec_X L1_0 L0_1_Inv))
(eval (/prec_X L1_0 L2_1_Inv))
(eval (/prec_X L1_0 LAST))
(eval (/prec_X L1_0 L2_2))
(eval (/prec_X L1_0 L3_2))
(eval (/prec_X L1_0 L3_0))
(eval (/prec_X L1_0 L1_1_Inv))
(eval (/prec_X L1_0 L1_2))
(eval (/prec_X L1_0 L3_1_Inv))
(eval (/prec_X L1_0 L3_1_Ret))
(eval (/prec_X L0_1_Inv L2_1_Ret))
(eval (/prec_X L0_1_Inv L2_0))
(eval (/prec_X L0_1_Inv L1_1_Ret))
(eval (/prec_X L0_1_Inv L0_1_Ret))
(eval (/prec_X L0_1_Inv L1_0))
(eval (/prec_X L0_1_Inv L0_1_Inv))
(eval (/prec_X L0_1_Inv L2_1_Inv))
(eval (/prec_X L0_1_Inv LAST))
(eval (/prec_X L0_1_Inv L2_2))
(eval (/prec_X L0_1_Inv L3_2))
(eval (/prec_X L0_1_Inv L3_0))
(eval (/prec_X L0_1_Inv L1_1_Inv))
(eval (/prec_X L0_1_Inv L1_2))
(eval (/prec_X L0_1_Inv L3_1_Inv))
(eval (/prec_X L0_1_Inv L3_1_Ret))
(eval (/prec_X L2_1_Inv L2_1_Ret))
(eval (/prec_X L2_1_Inv L2_0))
(eval (/prec_X L2_1_Inv L1_1_Ret))
(eval (/prec_X L2_1_Inv L0_1_Ret))
(eval (/prec_X L2_1_Inv L1_0))
(eval (/prec_X L2_1_Inv L0_1_Inv))
(eval (/prec_X L2_1_Inv L2_1_Inv))
(eval (/prec_X L2_1_Inv LAST))
(eval (/prec_X L2_1_Inv L2_2))
(eval (/prec_X L2_1_Inv L3_2))
(eval (/prec_X L2_1_Inv L3_0))
(eval (/prec_X L2_1_Inv L1_1_Inv))
(eval (/prec_X L2_1_Inv L1_2))
(eval (/prec_X L2_1_Inv L3_1_Inv))
(eval (/prec_X L2_1_Inv L3_1_Ret))
(eval (/prec_X LAST L2_1_Ret))
(eval (/prec_X LAST L2_0))
(eval (/prec_X LAST L1_1_Ret))
(eval (/prec_X LAST L0_1_Ret))
(eval (/prec_X LAST L1_0))
(eval (/prec_X LAST L0_1_Inv))
(eval (/prec_X LAST L2_1_Inv))
(eval (/prec_X LAST LAST))
(eval (/prec_X LAST L2_2))
(eval (/prec_X LAST L3_2))
(eval (/prec_X LAST L3_0))
(eval (/prec_X LAST L1_1_Inv))
(eval (/prec_X LAST L1_2))
(eval (/prec_X LAST L3_1_Inv))
(eval (/prec_X LAST L3_1_Ret))
(eval (/prec_X L2_2 L2_1_Ret))
(eval (/prec_X L2_2 L2_0))
(eval (/prec_X L2_2 L1_1_Ret))
(eval (/prec_X L2_2 L0_1_Ret))
(eval (/prec_X L2_2 L1_0))
(eval (/prec_X L2_2 L0_1_Inv))
(eval (/prec_X L2_2 L2_1_Inv))
(eval (/prec_X L2_2 LAST))
(eval (/prec_X L2_2 L2_2))
(eval (/prec_X L2_2 L3_2))
(eval (/prec_X L2_2 L3_0))
(eval (/prec_X L2_2 L1_1_Inv))
(eval (/prec_X L2_2 L1_2))
(eval (/prec_X L2_2 L3_1_Inv))
(eval (/prec_X L2_2 L3_1_Ret))
(eval (/prec_X L3_2 L2_1_Ret))
(eval (/prec_X L3_2 L2_0))
(eval (/prec_X L3_2 L1_1_Ret))
(eval (/prec_X L3_2 L0_1_Ret))
(eval (/prec_X L3_2 L1_0))
(eval (/prec_X L3_2 L0_1_Inv))
(eval (/prec_X L3_2 L2_1_Inv))
(eval (/prec_X L3_2 LAST))
(eval (/prec_X L3_2 L2_2))
(eval (/prec_X L3_2 L3_2))
(eval (/prec_X L3_2 L3_0))
(eval (/prec_X L3_2 L1_1_Inv))
(eval (/prec_X L3_2 L1_2))
(eval (/prec_X L3_2 L3_1_Inv))
(eval (/prec_X L3_2 L3_1_Ret))
(eval (/prec_X L3_0 L2_1_Ret))
(eval (/prec_X L3_0 L2_0))
(eval (/prec_X L3_0 L1_1_Ret))
(eval (/prec_X L3_0 L0_1_Ret))
(eval (/prec_X L3_0 L1_0))
(eval (/prec_X L3_0 L0_1_Inv))
(eval (/prec_X L3_0 L2_1_Inv))
(eval (/prec_X L3_0 LAST))
(eval (/prec_X L3_0 L2_2))
(eval (/prec_X L3_0 L3_2))
(eval (/prec_X L3_0 L3_0))
(eval (/prec_X L3_0 L1_1_Inv))
(eval (/prec_X L3_0 L1_2))
(eval (/prec_X L3_0 L3_1_Inv))
(eval (/prec_X L3_0 L3_1_Ret))
(eval (/prec_X L1_1_Inv L2_1_Ret))
(eval (/prec_X L1_1_Inv L2_0))
(eval (/prec_X L1_1_Inv L1_1_Ret))
(eval (/prec_X L1_1_Inv L0_1_Ret))
(eval (/prec_X L1_1_Inv L1_0))
(eval (/prec_X L1_1_Inv L0_1_Inv))
(eval (/prec_X L1_1_Inv L2_1_Inv))
(eval (/prec_X L1_1_Inv LAST))
(eval (/prec_X L1_1_Inv L2_2))
(eval (/prec_X L1_1_Inv L3_2))
(eval (/prec_X L1_1_Inv L3_0))
(eval (/prec_X L1_1_Inv L1_1_Inv))
(eval (/prec_X L1_1_Inv L1_2))
(eval (/prec_X L1_1_Inv L3_1_Inv))
(eval (/prec_X L1_1_Inv L3_1_Ret))
(eval (/prec_X L1_2 L2_1_Ret))
(eval (/prec_X L1_2 L2_0))
(eval (/prec_X L1_2 L1_1_Ret))
(eval (/prec_X L1_2 L0_1_Ret))
(eval (/prec_X L1_2 L1_0))
(eval (/prec_X L1_2 L0_1_Inv))
(eval (/prec_X L1_2 L2_1_Inv))
(eval (/prec_X L1_2 LAST))
(eval (/prec_X L1_2 L2_2))
(eval (/prec_X L1_2 L3_2))
(eval (/prec_X L1_2 L3_0))
(eval (/prec_X L1_2 L1_1_Inv))
(eval (/prec_X L1_2 L1_2))
(eval (/prec_X L1_2 L3_1_Inv))
(eval (/prec_X L1_2 L3_1_Ret))
(eval (/prec_X L3_1_Inv L2_1_Ret))
(eval (/prec_X L3_1_Inv L2_0))
(eval (/prec_X L3_1_Inv L1_1_Ret))
(eval (/prec_X L3_1_Inv L0_1_Ret))
(eval (/prec_X L3_1_Inv L1_0))
(eval (/prec_X L3_1_Inv L0_1_Inv))
(eval (/prec_X L3_1_Inv L2_1_Inv))
(eval (/prec_X L3_1_Inv LAST))
(eval (/prec_X L3_1_Inv L2_2))
(eval (/prec_X L3_1_Inv L3_2))
(eval (/prec_X L3_1_Inv L3_0))
(eval (/prec_X L3_1_Inv L1_1_Inv))
(eval (/prec_X L3_1_Inv L1_2))
(eval (/prec_X L3_1_Inv L3_1_Inv))
(eval (/prec_X L3_1_Inv L3_1_Ret))
(eval (/prec_X L3_1_Ret L2_1_Ret))
(eval (/prec_X L3_1_Ret L2_0))
(eval (/prec_X L3_1_Ret L1_1_Ret))
(eval (/prec_X L3_1_Ret L0_1_Ret))
(eval (/prec_X L3_1_Ret L1_0))
(eval (/prec_X L3_1_Ret L0_1_Inv))
(eval (/prec_X L3_1_Ret L2_1_Inv))
(eval (/prec_X L3_1_Ret LAST))
(eval (/prec_X L3_1_Ret L2_2))
(eval (/prec_X L3_1_Ret L3_2))
(eval (/prec_X L3_1_Ret L3_0))
(eval (/prec_X L3_1_Ret L1_1_Inv))
(eval (/prec_X L3_1_Ret L1_2))
(eval (/prec_X L3_1_Ret L3_1_Inv))
(eval (/prec_X L3_1_Ret L3_1_Ret))
(echo "--------------------------------------")
