
Loc {
   writer: AtomicRegister
   oldValue: AtomicRegister
   newValue: AtomicRegister

   // These could be basic registers.
   // The bug exists even with these stronger registers.
}

DSTM {
   state: AtomicCASRegister[4]   // To store thread identifiers
   // Let state[3] be the state of the init trans
   start: AtomicCASRegister[2]   // To store Ref<Locator>

   rset: TLocal AtomicRegister[2]
   // This could be a basic register array.
   // The bug exists even with these stronger registers.

   def this() {
      // init state and start
      I01>    state[1].write(\R)
      I02>    state[2].write(\R)
      I03>    state[3].write(\C)
      I04>    loc1 = new Loc()
      I05>    loc1.writer.write(3)
      I06>    loc1.newValue.write(0)
      I07>    start[0].write(loc1)
      I08>    loc2 = new Loc()
      I09>    loc2.writer.write(3)
      I10>    loc2.newValue.write(0)
      I11>    start[1].write(loc2)
   }

   def read(i) {
      R0>    s = state[t].read()
      R1>    if (s = \A)
      R2>       return \A
      R3>    start = start[i].read()
      // --------------
      // Stable value
      R4>    tp = start.writer.read()
      R5>    sp = state[tp].read()
      R6>    if (tp != t && sp = \R)
      R7>       state[tp].cas(\R, \A)
      R8>    if (sp = \A)
      R9>       v = start.oldValue.read()
             else
      R10>      v = start.newValue.read()
      // --------------
      R11>   if (tp != t)
      R12>      rset[i].write(v)
      // --------------
      // Validate
      R13>   rv0 = rset[0].read()
      R14>   if (rv0 != \bot) {
      R15>      s0 = start[0].read()
      R16>      wt0 = s0.writer.read()
      R17>      st0 = state[wt0].read()
      R18>      if (st0 = \C)
      R19>         vp0 = s0.newValue.read()
                else
      R20>         vp0 = s0.oldValue.read()
      R21>      if (rv0 != vp0)
      R22>         return \A
      R23>      cts0 = state[t].read()
      R24>      if (cts0 != \R)
      R25>         return \A
             }
      R26>   rv1 = rset[1].read()
      R27>   if (rv1 != \bot) {
      R28>      s1 = start[1].read()
      R29>      wt1 = s1.writer.read()
      R30>      st1 = state[wt1].read()
      R31>      if (st1 = \C)
      R32>         vp1 = s1.newValue.read()
                else
      R33>         vp1 = s1.oldValue.read()
      R34>      if (rv1 != vp1)
      R35>         return \A
      R36>      cts1 = state[t].read()
      R37>      if (cts1 != \R)
      R38>         return \A
             }
      // --------------
      R39>   return v
   }

   def write(i, v) {
      W0>    s = state[t].read()
      W1>    if (s = \A)
      W2>       return \A
      W3>    start = start[i].read()
      W4>    wt = start.writer.read()
      W5>    if (wt = t) {
      W6>       start.newValue.write(v)
      W7>       return \Ok
             }
      // --------------
      // Stable value
      W8>    tp = start.writer.read()
      W9>    sp = state[tp].read()
      W10>   if (tp != t && sp = \R)
      W11>      state[tp].cas(\R, \A)
      W12>   if (sp = \A)
      W13>      vp = start.oldValue.read()
             else
      W14>      vp = start.newValue.read()
      // --------------
      W15>   startp = new Loc()
      W16>   startp.writer.write(t)
      W17>   startp.oldValue.write(vp)
      W18>   startp.newValue.write(v)
      W19>   b = start[i].cas(start, startp)
      W20>   if (b = 1)
      W21>      return \Ok
             else
      W22>      return \A
   }

   def commit() {
      C01>   rv0 = rset[0].read()
      C02>   if (rv0 != \bot) {
      C03>      s0 = start[0].read()
      C04>      wt0 = s0.writer.read()
      C05>      st0 = state[wt0].read()
      C06>      if (st0 = \C)
      C07>         vp0 = s0.newValue.read()
                else
      C08>         vp0 = s0.oldValue.read()
      C09>      if (rv0 != vp0)
      C10>         return \A
      C11>      cts0 = state[t].read()
      C12>      if (cts0 != \R)
      C13>         return \A
             }
      C14>   rv1 = rset[1].read()
      C15>   if (rv1 != \bot) {
      C16>      s1 = start[1].read()
      C17>      wt1 = s1.writer.read()
      C18>      st1 = state[wt1].read()
      C19>      if (st1 = \C)
      C20>         vp1 = s1.newValue.read()
                else
      C21>         vp1 = s1.oldValue.read()
      C22>      if (rv1 != vp1)
      C23>         return \A
      C24>      cts1 = state[t].read()
      C25>      if (cts1 != \R)
      C26>         return \A
             }
      C27>   b = state[t].cas(\R, \C)
      C28>   if (b = 1)
      C29>      return \C
             else
      C30>      return \A
   }

   main {
      {
         S11>    rset[0].write(\bot)
         S12>    rset[1].write(\bot)

         L11>   v10 = read(0)
         L12>   v11 = read(1)
         L13>   write(0, 7)
         L14>   c1 = commit()
      } || {
         S21>    rset[0].write(\bot)
         S22>    rset[1].write(\bot)

         L21>   v20 = read(0)
         L22>   v21 = read(1)
         L23>   write(1, 7)
         L24>   c2 = commit()
      }
   }

   order {
//      R0 -> R3 &&
      R3 -> R15 &&
      R3 -> R28 &&
//      W0 -> W3 &&
      W16 -> W19 &&
      W17 -> W19 &&
      W18 -> W19 &&
      C02 -> C27 &&
      C15 -> C27
   }

   spec {
      ~(
         v10 = 0 /\
         v11 = 0 /\
         v20 = 0 /\
         v21 = 0 /\
         c1 = \C /\
         c2 = \C
      )
   }
}

