
McRT {

   r: AtomicRegister[2]
   ver: AtomicRegister[2]
   lock: TryLock[2]

   rset: TLocal AtomicRegister[2]
   uset: TLocal AtomicRegister[2]
   // These regs could be basic register arrays

   def this() {
   //   T1>    rset[0].write(\bot)
   //   T2>    rset[1].write(\bot)
   //   T3>    uset[0].write(\bot)
   //   T4>    uset[1].write(\bot)
      L01>    lock[0].unlock()
      L02>    lock[1].unlock()
      L03>    r[0].write(0)
      L04>    r[1].write(0)
      L05>    ver[0].write(0)
      L06>    ver[1].write(0)
   }

   def read(i) {
      R0>    u = uset[i].read()
      R1>    if (u = \bot) {
      R2>       ve = ver[i].read()
      R3>       l = lock[i].read()
      R4>       if (l = 1) {
      R5>          ov0 = uset[0].read()
      R6>          if (ov0 != \bot) {
      R7>             r[0].write(ov0)
      R8>             lock[1].unlock()
                   }
      R9>          ov1 = uset[1].read()
      R10>         if (ov1 != \bot) {
      R11>            r[1].write(ov1)
      R12>            lock[1].unlock()
                   }
      R13>        return \A
                }
      R14>      r = rset[i].read()
      R15>      if (r = \bot)
      R16>         rset[i].write(ve)
             }
      R17>   v = r[i].read()
      R18>   return v
   }

   def write(i, v) {
      W0>    u = uset[i].read()
      W1>    if (u = \bot) {
      W2>       l = lock[i].tryLock()
      W3>       if (l = 0) {
      W4>          ov0 = uset[0].read()
      W5>          if (ov0 != \bot) {
      W6>             r[0].write(ov0)
      W7>             lock[0].unlock()
                   }
      W8>          ov1 = uset[1].read()
      W9>          if (ov1 != \bot) {
      W10>            r[1].write(ov1)
      W11>            lock[1].unlock()
                   }
      W12>        return \A
                }
      W13>      ov = r[i].read()
      W14>      uset[i].write(ov)
             }
      W15>   r[i].write(v)
      W16>   return \Ok
   }

   def commit() {
      C0>    ove0 = rset[0].read()
      C1>    if (ove0 != \bot) {
      C2>       l0 = lock[0].read()
      C3>       ve0 = ver[0].read()
      C4>       if ((l0 = 1)|| (ve0 != ove0)) {
      C5>          ov10 = uset[0].read()
      C6>          if (ov10 != \bot) {
      C7>             r[0].write(ov10)
      C8>             lock[0].unlock()
                   }
      C9>          ov11 = uset[1].read()
      C10>         if (ov11 != \bot) {
      C11>            r[1].write(ov11)
      C12>            lock[1].unlock()
                   }
      C13>         return \A
                }
             }
      C14>   ove1 = rset[1].read()
      C15>   if (ove1 != \bot) {
      C16>      l1 = lock[1].read()
      C17>      ve1 = ver[1].read()
      C18>      if ((l1 = 1) || (ve1 != ove1)) {
      C19>         ov20 = uset[0].read()
      C20>         if (ov20 != \bot) {
      C21>            r[0].write(ov20)
      C22>            lock[0].unlock()
                   }
      C23>         ov21 = uset[1].read()
      C24>         if (ov21 != \bot) {
      C25>            r[1].write(ov21)
      C26>            lock[1].unlock()
                   }
      C27>         return \A
                }
             }

      C28>   u0 = uset[0].read()
      C29>   if (u0 != \bot) {
      C30>      v0 = ver[0].read()
      C31>      vp0 = v0 + 1
      C32>      ver[0].write(vp0)
      C33>      lock[0].unlock()
             }
      C34>   u1 = uset[1].read()
      C35>   if (u1 != \bot) {
      C36>      v1 = ver[1].read()
      C37>      vp1 = v1 + 1
      C38>      ver[1].write(vp1)
      C39>      lock[1].unlock()
             }

      C40>   return \C
   }

//  write_T1(1,v1):OK
//  read_T2(1):v1
//  write_T1(1,v2):OK
//  commit_T1():C
//  commit_T1():A

   main {
      {
         I11>    rset[0].write(\bot)
         I12>    rset[1].write(\bot)
         I13>    uset[0].write(\bot)
         I14>    uset[1].write(\bot)

         L11>   write(1, 7)
         L12>   write(1, 14)
         L13>   c1 = commit()
      } || {
         I21>    rset[0].write(\bot)
         I22>    rset[1].write(\bot)
         I23>    uset[0].write(\bot)
         I24>    uset[1].write(\bot)

         L21>   r1 = read(1)
         L22>   commit()
      }
   }

   order {
      R2 -> R3 &&
      R3 -> R17 &&
      C2 -> C3 &&
      C16 -> C17
   }

   spec {
      ~(
         r1 = 7  /\
         c1 = \C
      )
   }
}

