//
// Generated by JTB 1.3.2
//

package speclang.spec.syntaxanalysis.parser.visitor;
import speclang.spec.syntaxanalysis.parser.syntaxtree.*;
import java.util.*;

/**
 * Provides default methods which visit each node in the tree in depth-first
 * order.  Your visitors may extend this class.
 */
public class GJDepthFirst<R,A> implements GJVisitor<R,A> {
   //
   // Auto class visitors--probably don't need to be overridden.
   //
   public R visit(NodeList n, A argu) {
      R _ret=null;
      int _count=0;
      for ( Enumeration<Node> e = n.elements(); e.hasMoreElements(); ) {
         e.nextElement().accept(this,argu);
         _count++;
      }
      return _ret;
   }

   public R visit(NodeListOptional n, A argu) {
      if ( n.present() ) {
         R _ret=null;
         int _count=0;
         for ( Enumeration<Node> e = n.elements(); e.hasMoreElements(); ) {
            e.nextElement().accept(this,argu);
            _count++;
         }
         return _ret;
      }
      else
         return null;
   }

   public R visit(NodeOptional n, A argu) {
      if ( n.present() )
         return n.node.accept(this,argu);
      else
         return null;
   }

   public R visit(NodeSequence n, A argu) {
      R _ret=null;
      int _count=0;
      for ( Enumeration<Node> e = n.elements(); e.hasMoreElements(); ) {
         e.nextElement().accept(this,argu);
         _count++;
      }
      return _ret;
   }

   public R visit(NodeToken n, A argu) { return null; }

   //
   // User-generated visitor methods below
   //

   /**
    * f0 -> n0=Identifier()
    * f1 -> n2="{"
    * f2 -> ( n4=Decl() )*
    * f3 -> ( n6=Def() )*
    * f4 -> n8="main"
    * f5 -> n10="{"
    * f6 -> n11=ParBlocks()
    * f7 -> n13="}"
    * f8 -> n15="order"
    * f9 -> n17="{"
    * f10 -> n18=Orders()
    * f11 -> n20="}"
    * f12 -> n22="bug"
    * f13 -> n24="{"
    * f14 -> n25=Constraints()
    * f15 -> n27="}"
    * f16 -> n29="}"
    * f17 -> n31=<EOF>
    */
   public R visit(File n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
      n.f6.accept(this, argu);
      n.f7.accept(this, argu);
      n.f8.accept(this, argu);
      n.f9.accept(this, argu);
      n.f10.accept(this, argu);
      n.f11.accept(this, argu);
      n.f12.accept(this, argu);
      n.f13.accept(this, argu);
      n.f14.accept(this, argu);
      n.f15.accept(this, argu);
      n.f16.accept(this, argu);
      n.f17.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> ( n1=AtomicRegDecl() | n2=RegDecl() | n3=LockDecl() )
    */
   public R visit(Decl n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> n0=Obj()
    * f1 -> n2=":"
    * f2 -> n4="AtomicRegister"
    */
   public R visit(AtomicRegDecl n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> n0=Obj()
    * f1 -> n2=":"
    * f2 -> n4="Register"
    */
   public R visit(RegDecl n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> n0=Obj()
    * f1 -> n2=":"
    * f2 -> n4="Lock"
    */
   public R visit(LockDecl n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> n0=Identifier()
    */
   public R visit(Obj n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> n1="def"
    * f1 -> n2=Name()
    * f2 -> n4="("
    * f3 -> n5=Vars()
    * f4 -> n7=")"
    * f5 -> n8=StatementBlock()
    */
   public R visit(Def n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> n0=Identifier()
    */
   public R visit(Name n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> ( n1=MethodCall() | n2=IfThenElse() | n3=StatementBlock() | n4=Return() )
    */
   public R visit(Statement n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> (  n2=Identifier() n4=">" )?
    */
   public R visit(Label n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> n0=Label()
    * f1 -> ( n2=Receiver() )?
    * f2 -> n3=Name()
    * f3 -> n5="("
    * f4 -> n6=Varls()
    * f5 -> n8=")"
    * f6 -> (  n12=":" n13=Var() )?
    */
   public R visit(MethodCall n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
      n.f6.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> n0=Obj()
    * f1 -> n2="."
    */
   public R visit(Receiver n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> n0=Label()
    * f1 -> n2="if"
    * f2 -> n4="("
    * f3 -> n5=BoolExp()
    * f4 -> n7=")"
    * f5 -> n8=Statement()
    * f6 -> ( n10=ElseClause() )?
    */
   public R visit(IfThenElse n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
      n.f6.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> n1="else"
    * f1 -> n2=Statement()
    */
   public R visit(ElseClause n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> n1="{"
    * f1 -> ( n3=Statement() )*
    * f2 -> n5="}"
    */
   public R visit(StatementBlock n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> (  n2=Var() ( n4=VarsRest() )* )?
    */
   public R visit(Vars n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> n1=","
    * f1 -> n2=Var()
    */
   public R visit(VarsRest n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> (  n2=Varl() ( n4=VarlsRest() )* )?
    */
   public R visit(Varls n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> n1=","
    * f1 -> n2=Varl()
    */
   public R visit(VarlsRest n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> ( n1=Var() | n2=Val() )
    */
   public R visit(Varl n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> n0=Identifier()
    */
   public R visit(Var n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> n0=IntegerLiteral()
    */
   public R visit(Val n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> n0=OrExp()
    */
   public R visit(BoolExp n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> n0=AndExp()
    * f1 -> ( n2=OrExpRest() )*
    */
   public R visit(OrExp n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> n1="||"
    * f1 -> n2=AndExp()
    */
   public R visit(OrExpRest n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> n0=NotExp()
    * f1 -> ( n2=AndExpRest() )*
    */
   public R visit(AndExp n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> n1="&&"
    * f1 -> n2=NotExp()
    */
   public R visit(AndExpRest n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> ( n2="!" )?
    * f1 -> n3=Atom()
    */
   public R visit(NotExp n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> ( n1=ParExp() | n2=RelExp() )
    */
   public R visit(Atom n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> n1="("
    * f1 -> n2=BoolExp()
    * f2 -> n4=")"
    */
   public R visit(ParExp n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> ( n1=EqExp() | n2=LTExp() | n3=GTExp() )
    */
   public R visit(RelExp n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> n0=Varl()
    * f1 -> n2="="
    * f2 -> n3=Varl()
    */
   public R visit(EqExp n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> n0=Varl()
    * f1 -> n2="<"
    * f2 -> n3=Varl()
    */
   public R visit(LTExp n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> n0=Varl()
    * f1 -> n2=">"
    * f2 -> n3=Varl()
    */
   public R visit(GTExp n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> n0=StatementBlock()
    * f1 -> ( n2=ParBlocksRest() )*
    */
   public R visit(ParBlocks n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> n1="||"
    * f1 -> n2=StatementBlock()
    */
   public R visit(ParBlocksRest n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> n0=Order()
    * f1 -> ( n2=OrdersRest() )*
    */
   public R visit(Orders n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> n1="&&"
    * f1 -> n2=Order()
    */
   public R visit(OrdersRest n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> n0=Identifier()
    * f1 -> n2="->"
    * f2 -> n3=Identifier()
    */
   public R visit(Order n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> n0=Constraint()
    * f1 -> ( n2=ConstraintsRest() )*
    */
   public R visit(Constraints n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> n1="&&"
    * f1 -> n2=Constraint()
    */
   public R visit(ConstraintsRest n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> n0=Var()
    * f1 -> n2="="
    * f2 -> n3=Val()
    */
   public R visit(Constraint n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> n0=Label()
    * f1 -> n2="return"
    * f2 -> ( n4=Varl() )?
    */
   public R visit(Return n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> n1=<INTEGER_LITERAL>
    */
   public R visit(IntegerLiteral n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> n1=<STRING_LITERAL>
    */
   public R visit(StringLiteral n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> n1=<IDENTIFIER>
    */
   public R visit(Identifier n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

}
