//
// Generated by JTB 1.3.2
//

package speclang.spec.syntaxanalysis.parser.visitor;
import speclang.spec.syntaxanalysis.parser.syntaxtree.*;
import java.util.*;

/**
 * All GJ visitors must implement this interface.
 */

public interface GJVisitor<R,A> {

   //
   // GJ Auto class visitors
   //

   public R visit(NodeList n, A argu);
   public R visit(NodeListOptional n, A argu);
   public R visit(NodeOptional n, A argu);
   public R visit(NodeSequence n, A argu);
   public R visit(NodeToken n, A argu);

   //
   // User-generated visitor methods below
   //

   /**
    * f0 -> n0=Identifier()
    * f1 -> n2="{"
    * f2 -> ( n4=Decl() )*
    * f3 -> ( n6=Def() )*
    * f4 -> n8="main"
    * f5 -> n10="{"
    * f6 -> n11=ParBlocks()
    * f7 -> n13="}"
    * f8 -> n15="order"
    * f9 -> n17="{"
    * f10 -> n18=Orders()
    * f11 -> n20="}"
    * f12 -> n22="bug"
    * f13 -> n24="{"
    * f14 -> n25=Constraints()
    * f15 -> n27="}"
    * f16 -> n29="}"
    * f17 -> n31=<EOF>
    */
   public R visit(File n, A argu);

   /**
    * f0 -> ( n1=AtomicRegDecl() | n2=RegDecl() | n3=LockDecl() )
    */
   public R visit(Decl n, A argu);

   /**
    * f0 -> n0=Obj()
    * f1 -> n2=":"
    * f2 -> n4="AtomicRegister"
    */
   public R visit(AtomicRegDecl n, A argu);

   /**
    * f0 -> n0=Obj()
    * f1 -> n2=":"
    * f2 -> n4="Register"
    */
   public R visit(RegDecl n, A argu);

   /**
    * f0 -> n0=Obj()
    * f1 -> n2=":"
    * f2 -> n4="Lock"
    */
   public R visit(LockDecl n, A argu);

   /**
    * f0 -> n0=Identifier()
    */
   public R visit(Obj n, A argu);

   /**
    * f0 -> n1="def"
    * f1 -> n2=Name()
    * f2 -> n4="("
    * f3 -> n5=Vars()
    * f4 -> n7=")"
    * f5 -> n8=StatementBlock()
    */
   public R visit(Def n, A argu);

   /**
    * f0 -> n0=Identifier()
    */
   public R visit(Name n, A argu);

   /**
    * f0 -> ( n1=MethodCall() | n2=IfThenElse() | n3=StatementBlock() | n4=Return() )
    */
   public R visit(Statement n, A argu);

   /**
    * f0 -> (  n2=Identifier() n4=">" )?
    */
   public R visit(Label n, A argu);

   /**
    * f0 -> n0=Label()
    * f1 -> ( n2=Receiver() )?
    * f2 -> n3=Name()
    * f3 -> n5="("
    * f4 -> n6=Varls()
    * f5 -> n8=")"
    * f6 -> (  n12=":" n13=Var() )?
    */
   public R visit(MethodCall n, A argu);

   /**
    * f0 -> n0=Obj()
    * f1 -> n2="."
    */
   public R visit(Receiver n, A argu);

   /**
    * f0 -> n0=Label()
    * f1 -> n2="if"
    * f2 -> n4="("
    * f3 -> n5=BoolExp()
    * f4 -> n7=")"
    * f5 -> n8=Statement()
    * f6 -> ( n10=ElseClause() )?
    */
   public R visit(IfThenElse n, A argu);

   /**
    * f0 -> n1="else"
    * f1 -> n2=Statement()
    */
   public R visit(ElseClause n, A argu);

   /**
    * f0 -> n1="{"
    * f1 -> ( n3=Statement() )*
    * f2 -> n5="}"
    */
   public R visit(StatementBlock n, A argu);

   /**
    * f0 -> (  n2=Var() ( n4=VarsRest() )* )?
    */
   public R visit(Vars n, A argu);

   /**
    * f0 -> n1=","
    * f1 -> n2=Var()
    */
   public R visit(VarsRest n, A argu);

   /**
    * f0 -> (  n2=Varl() ( n4=VarlsRest() )* )?
    */
   public R visit(Varls n, A argu);

   /**
    * f0 -> n1=","
    * f1 -> n2=Varl()
    */
   public R visit(VarlsRest n, A argu);

   /**
    * f0 -> ( n1=Var() | n2=Val() )
    */
   public R visit(Varl n, A argu);

   /**
    * f0 -> n0=Identifier()
    */
   public R visit(Var n, A argu);

   /**
    * f0 -> n0=IntegerLiteral()
    */
   public R visit(Val n, A argu);

   /**
    * f0 -> n0=OrExp()
    */
   public R visit(BoolExp n, A argu);

   /**
    * f0 -> n0=AndExp()
    * f1 -> ( n2=OrExpRest() )*
    */
   public R visit(OrExp n, A argu);

   /**
    * f0 -> n1="||"
    * f1 -> n2=AndExp()
    */
   public R visit(OrExpRest n, A argu);

   /**
    * f0 -> n0=NotExp()
    * f1 -> ( n2=AndExpRest() )*
    */
   public R visit(AndExp n, A argu);

   /**
    * f0 -> n1="&&"
    * f1 -> n2=NotExp()
    */
   public R visit(AndExpRest n, A argu);

   /**
    * f0 -> ( n2="!" )?
    * f1 -> n3=Atom()
    */
   public R visit(NotExp n, A argu);

   /**
    * f0 -> ( n1=ParExp() | n2=RelExp() )
    */
   public R visit(Atom n, A argu);

   /**
    * f0 -> n1="("
    * f1 -> n2=BoolExp()
    * f2 -> n4=")"
    */
   public R visit(ParExp n, A argu);

   /**
    * f0 -> ( n1=EqExp() | n2=LTExp() | n3=GTExp() )
    */
   public R visit(RelExp n, A argu);

   /**
    * f0 -> n0=Varl()
    * f1 -> n2="="
    * f2 -> n3=Varl()
    */
   public R visit(EqExp n, A argu);

   /**
    * f0 -> n0=Varl()
    * f1 -> n2="<"
    * f2 -> n3=Varl()
    */
   public R visit(LTExp n, A argu);

   /**
    * f0 -> n0=Varl()
    * f1 -> n2=">"
    * f2 -> n3=Varl()
    */
   public R visit(GTExp n, A argu);

   /**
    * f0 -> n0=StatementBlock()
    * f1 -> ( n2=ParBlocksRest() )*
    */
   public R visit(ParBlocks n, A argu);

   /**
    * f0 -> n1="||"
    * f1 -> n2=StatementBlock()
    */
   public R visit(ParBlocksRest n, A argu);

   /**
    * f0 -> n0=Order()
    * f1 -> ( n2=OrdersRest() )*
    */
   public R visit(Orders n, A argu);

   /**
    * f0 -> n1="&&"
    * f1 -> n2=Order()
    */
   public R visit(OrdersRest n, A argu);

   /**
    * f0 -> n0=Identifier()
    * f1 -> n2="->"
    * f2 -> n3=Identifier()
    */
   public R visit(Order n, A argu);

   /**
    * f0 -> n0=Constraint()
    * f1 -> ( n2=ConstraintsRest() )*
    */
   public R visit(Constraints n, A argu);

   /**
    * f0 -> n1="&&"
    * f1 -> n2=Constraint()
    */
   public R visit(ConstraintsRest n, A argu);

   /**
    * f0 -> n0=Var()
    * f1 -> n2="="
    * f2 -> n3=Val()
    */
   public R visit(Constraint n, A argu);

   /**
    * f0 -> n0=Label()
    * f1 -> n2="return"
    * f2 -> ( n4=Varl() )?
    */
   public R visit(Return n, A argu);

   /**
    * f0 -> n1=<INTEGER_LITERAL>
    */
   public R visit(IntegerLiteral n, A argu);

   /**
    * f0 -> n1=<STRING_LITERAL>
    */
   public R visit(StringLiteral n, A argu);

   /**
    * f0 -> n1=<IDENTIFIER>
    */
   public R visit(Identifier n, A argu);

}
