//
// Generated by JTB 1.3.2
//

package speclang.spec.syntaxanalysis.parser.visitor;
import speclang.spec.syntaxanalysis.parser.syntaxtree.*;
import java.util.*;

/**
 * All void visitors must implement this interface.
 */

public interface Visitor {

   //
   // void Auto class visitors
   //

   public void visit(NodeList n);
   public void visit(NodeListOptional n);
   public void visit(NodeOptional n);
   public void visit(NodeSequence n);
   public void visit(NodeToken n);

   //
   // User-generated visitor methods below
   //

   /**
    * f0 -> n0=Identifier()
    * f1 -> n2="{"
    * f2 -> ( n4=Decl() )*
    * f3 -> ( n6=Def() )*
    * f4 -> n8="main"
    * f5 -> n10="{"
    * f6 -> n11=ParBlocks()
    * f7 -> n13="}"
    * f8 -> n15="order"
    * f9 -> n17="{"
    * f10 -> n18=Orders()
    * f11 -> n20="}"
    * f12 -> n22="bug"
    * f13 -> n24="{"
    * f14 -> n25=Constraints()
    * f15 -> n27="}"
    * f16 -> n29="}"
    * f17 -> n31=<EOF>
    */
   public void visit(File n);

   /**
    * f0 -> ( n1=AtomicRegDecl() | n2=RegDecl() | n3=LockDecl() )
    */
   public void visit(Decl n);

   /**
    * f0 -> n0=Obj()
    * f1 -> n2=":"
    * f2 -> n4="AtomicRegister"
    */
   public void visit(AtomicRegDecl n);

   /**
    * f0 -> n0=Obj()
    * f1 -> n2=":"
    * f2 -> n4="Register"
    */
   public void visit(RegDecl n);

   /**
    * f0 -> n0=Obj()
    * f1 -> n2=":"
    * f2 -> n4="Lock"
    */
   public void visit(LockDecl n);

   /**
    * f0 -> n0=Identifier()
    */
   public void visit(Obj n);

   /**
    * f0 -> n1="def"
    * f1 -> n2=Name()
    * f2 -> n4="("
    * f3 -> n5=Vars()
    * f4 -> n7=")"
    * f5 -> n8=StatementBlock()
    */
   public void visit(Def n);

   /**
    * f0 -> n0=Identifier()
    */
   public void visit(Name n);

   /**
    * f0 -> ( n1=MethodCall() | n2=IfThenElse() | n3=StatementBlock() | n4=Return() )
    */
   public void visit(Statement n);

   /**
    * f0 -> (  n2=Identifier() n4=">" )?
    */
   public void visit(Label n);

   /**
    * f0 -> n0=Label()
    * f1 -> ( n2=Receiver() )?
    * f2 -> n3=Name()
    * f3 -> n5="("
    * f4 -> n6=Varls()
    * f5 -> n8=")"
    * f6 -> (  n12=":" n13=Var() )?
    */
   public void visit(MethodCall n);

   /**
    * f0 -> n0=Obj()
    * f1 -> n2="."
    */
   public void visit(Receiver n);

   /**
    * f0 -> n0=Label()
    * f1 -> n2="if"
    * f2 -> n4="("
    * f3 -> n5=BoolExp()
    * f4 -> n7=")"
    * f5 -> n8=Statement()
    * f6 -> ( n10=ElseClause() )?
    */
   public void visit(IfThenElse n);

   /**
    * f0 -> n1="else"
    * f1 -> n2=Statement()
    */
   public void visit(ElseClause n);

   /**
    * f0 -> n1="{"
    * f1 -> ( n3=Statement() )*
    * f2 -> n5="}"
    */
   public void visit(StatementBlock n);

   /**
    * f0 -> (  n2=Var() ( n4=VarsRest() )* )?
    */
   public void visit(Vars n);

   /**
    * f0 -> n1=","
    * f1 -> n2=Var()
    */
   public void visit(VarsRest n);

   /**
    * f0 -> (  n2=Varl() ( n4=VarlsRest() )* )?
    */
   public void visit(Varls n);

   /**
    * f0 -> n1=","
    * f1 -> n2=Varl()
    */
   public void visit(VarlsRest n);

   /**
    * f0 -> ( n1=Var() | n2=Val() )
    */
   public void visit(Varl n);

   /**
    * f0 -> n0=Identifier()
    */
   public void visit(Var n);

   /**
    * f0 -> n0=IntegerLiteral()
    */
   public void visit(Val n);

   /**
    * f0 -> n0=OrExp()
    */
   public void visit(BoolExp n);

   /**
    * f0 -> n0=AndExp()
    * f1 -> ( n2=OrExpRest() )*
    */
   public void visit(OrExp n);

   /**
    * f0 -> n1="||"
    * f1 -> n2=AndExp()
    */
   public void visit(OrExpRest n);

   /**
    * f0 -> n0=NotExp()
    * f1 -> ( n2=AndExpRest() )*
    */
   public void visit(AndExp n);

   /**
    * f0 -> n1="&&"
    * f1 -> n2=NotExp()
    */
   public void visit(AndExpRest n);

   /**
    * f0 -> ( n2="!" )?
    * f1 -> n3=Atom()
    */
   public void visit(NotExp n);

   /**
    * f0 -> ( n1=ParExp() | n2=RelExp() )
    */
   public void visit(Atom n);

   /**
    * f0 -> n1="("
    * f1 -> n2=BoolExp()
    * f2 -> n4=")"
    */
   public void visit(ParExp n);

   /**
    * f0 -> ( n1=EqExp() | n2=LTExp() | n3=GTExp() )
    */
   public void visit(RelExp n);

   /**
    * f0 -> n0=Varl()
    * f1 -> n2="="
    * f2 -> n3=Varl()
    */
   public void visit(EqExp n);

   /**
    * f0 -> n0=Varl()
    * f1 -> n2="<"
    * f2 -> n3=Varl()
    */
   public void visit(LTExp n);

   /**
    * f0 -> n0=Varl()
    * f1 -> n2=">"
    * f2 -> n3=Varl()
    */
   public void visit(GTExp n);

   /**
    * f0 -> n0=StatementBlock()
    * f1 -> ( n2=ParBlocksRest() )*
    */
   public void visit(ParBlocks n);

   /**
    * f0 -> n1="||"
    * f1 -> n2=StatementBlock()
    */
   public void visit(ParBlocksRest n);

   /**
    * f0 -> n0=Order()
    * f1 -> ( n2=OrdersRest() )*
    */
   public void visit(Orders n);

   /**
    * f0 -> n1="&&"
    * f1 -> n2=Order()
    */
   public void visit(OrdersRest n);

   /**
    * f0 -> n0=Identifier()
    * f1 -> n2="->"
    * f2 -> n3=Identifier()
    */
   public void visit(Order n);

   /**
    * f0 -> n0=Constraint()
    * f1 -> ( n2=ConstraintsRest() )*
    */
   public void visit(Constraints n);

   /**
    * f0 -> n1="&&"
    * f1 -> n2=Constraint()
    */
   public void visit(ConstraintsRest n);

   /**
    * f0 -> n0=Var()
    * f1 -> n2="="
    * f2 -> n3=Val()
    */
   public void visit(Constraint n);

   /**
    * f0 -> n0=Label()
    * f1 -> n2="return"
    * f2 -> ( n4=Varl() )?
    */
   public void visit(Return n);

   /**
    * f0 -> n1=<INTEGER_LITERAL>
    */
   public void visit(IntegerLiteral n);

   /**
    * f0 -> n1=<STRING_LITERAL>
    */
   public void visit(StringLiteral n);

   /**
    * f0 -> n1=<IDENTIFIER>
    */
   public void visit(Identifier n);

}

