//
// Generated by JTB 1.3.2
//

package speclang.spec.syntaxanalysis.visitor;
import speclang.spec.syntaxanalysis.syntaxtree.*;
import java.util.*;

/**
 * Provides default methods which visit each node in the tree in depth-first
 * order.  Your visitors may extend this class.
 */
public class DepthFirstVisitor implements Visitor {
   //
   // Auto class visitors--probably don't need to be overridden.
   //
   public void visit(NodeList n) {
      for ( Enumeration<Node> e = n.elements(); e.hasMoreElements(); )
         e.nextElement().accept(this);
   }

   public void visit(NodeListOptional n) {
      if ( n.present() )
         for ( Enumeration<Node> e = n.elements(); e.hasMoreElements(); )
            e.nextElement().accept(this);
   }

   public void visit(NodeOptional n) {
      if ( n.present() )
         n.node.accept(this);
   }

   public void visit(NodeSequence n) {
      for ( Enumeration<Node> e = n.elements(); e.hasMoreElements(); )
         e.nextElement().accept(this);
   }

   public void visit(NodeToken n) { }

   //
   // User-generated visitor methods below
   //

   /**
    * f0 -> ( Struct() )?
    * f1 -> Identifier()
    * f2 -> "{"
    * f3 -> ( Decl() )*
    * f4 -> ( Def() )*
    * f5 -> "main"
    * f6 -> "{"
    * f7 -> ParBlocks()
    * f8 -> "}"
    * f9 -> ( "order" "{" Orders() "}" )?
    * f10 -> "spec"
    * f11 -> "{"
    * f12 -> Asser()
    * f13 -> "}"
    * f14 -> "}"
    * f15 -> <EOF>
    */
   public void visit(File n) {
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      n.f3.accept(this);
      n.f4.accept(this);
      n.f5.accept(this);
      n.f6.accept(this);
      n.f7.accept(this);
      n.f8.accept(this);
      n.f9.accept(this);
      n.f10.accept(this);
      n.f11.accept(this);
      n.f12.accept(this);
      n.f13.accept(this);
      n.f14.accept(this);
      n.f15.accept(this);
   }

   /**
    * f0 -> AtomicRegDecl()
    *       | AtomicCASRegDecl()
    *       | RegDecl()
    *       | LockDecl()
    *       | TryLockDecl()
    */
   public void visit(Decl n) {
      n.f0.accept(this);
   }

   /**
    * f0 -> Obj()
    * f1 -> ":"
    * f2 -> ( "TLocal" )?
    * f3 -> "AtomicRegister"
    * f4 -> ( "[" IntegerLiteral() "]" )?
    */
   public void visit(AtomicRegDecl n) {
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      n.f3.accept(this);
      n.f4.accept(this);
   }

   /**
    * f0 -> Obj()
    * f1 -> ":"
    * f2 -> ( "TLocal" )?
    * f3 -> "AtomicCASRegister"
    * f4 -> ( "[" IntegerLiteral() "]" )?
    */
   public void visit(AtomicCASRegDecl n) {
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      n.f3.accept(this);
      n.f4.accept(this);
   }

   /**
    * f0 -> Obj()
    * f1 -> ":"
    * f2 -> ( "TLocal" )?
    * f3 -> "BasicRegister"
    * f4 -> ( "[" IntegerLiteral() "]" )?
    */
   public void visit(RegDecl n) {
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      n.f3.accept(this);
      n.f4.accept(this);
   }

   /**
    * f0 -> Obj()
    * f1 -> ":"
    * f2 -> ( "TLocal" )?
    * f3 -> "Lock"
    * f4 -> ( "[" IntegerLiteral() "]" )?
    */
   public void visit(LockDecl n) {
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      n.f3.accept(this);
      n.f4.accept(this);
   }

   /**
    * f0 -> Obj()
    * f1 -> ":"
    * f2 -> ( "TLocal" )?
    * f3 -> "TryLock"
    * f4 -> ( "[" IntegerLiteral() "]" )?
    */
   public void visit(TryLockDecl n) {
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      n.f3.accept(this);
      n.f4.accept(this);
   }

   /**
    * f0 -> Identifier()
    */
   public void visit(Obj n) {
      n.f0.accept(this);
   }

   /**
    * f0 -> "def"
    * f1 -> Name()
    * f2 -> "("
    * f3 -> Vars()
    * f4 -> ")"
    * f5 -> StatementBlock()
    */
   public void visit(Def n) {
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      n.f3.accept(this);
      n.f4.accept(this);
      n.f5.accept(this);
   }

   /**
    * f0 -> Identifier()
    */
   public void visit(Name n) {
      n.f0.accept(this);
   }

   /**
    * f0 -> Identifier()
    * f1 -> "{"
    * f2 -> ( Decl() )*
    * f3 -> "}"
    */
   public void visit(Struct n) {
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      n.f3.accept(this);
   }

   /**
    * f0 -> MethodCall()
    *       | IfThenElse()
    *       | StatementBlock()
    *       | Return()
    *       | PlusStatement()
    *       | MinusStatement()
    *       | NewStatement()
    *       | FieldMethodCall()
    */
   public void visit(Statement n) {
      n.f0.accept(this);
   }

   /**
    * f0 -> ( Identifier() ">" )?
    */
   public void visit(Label n) {
      n.f0.accept(this);
   }

   /**
    * f0 -> Label()
    * f1 -> ( Var() "=" )?
    * f2 -> ( Receiver() )?
    * f3 -> Name()
    * f4 -> "("
    * f5 -> Varls()
    * f6 -> ")"
    */
   public void visit(MethodCall n) {
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      n.f3.accept(this);
      n.f4.accept(this);
      n.f5.accept(this);
      n.f6.accept(this);
   }

   /**
    * f0 -> Label()
    * f1 -> ( Var() "=" )?
    * f2 -> Var()
    * f3 -> "."
    * f4 -> Receiver()
    * f5 -> Name()
    * f6 -> "("
    * f7 -> Varls()
    * f8 -> ")"
    */
   public void visit(FieldMethodCall n) {
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      n.f3.accept(this);
      n.f4.accept(this);
      n.f5.accept(this);
      n.f6.accept(this);
      n.f7.accept(this);
      n.f8.accept(this);
   }

   /**
    * f0 -> "["
    * f1 -> Varl()
    * f2 -> "]"
    */
   public void visit(Index n) {
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
   }

   /**
    * f0 -> Obj()
    * f1 -> ( Index() )?
    * f2 -> "."
    */
   public void visit(Receiver n) {
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
   }

   /**
    * f0 -> Label()
    * f1 -> "if"
    * f2 -> "("
    * f3 -> BoolExp()
    * f4 -> ")"
    * f5 -> Statement()
    * f6 -> [ ElseClause() ]
    */
   public void visit(IfThenElse n) {
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      n.f3.accept(this);
      n.f4.accept(this);
      n.f5.accept(this);
      n.f6.accept(this);
   }

   /**
    * f0 -> "else"
    * f1 -> Statement()
    */
   public void visit(ElseClause n) {
      n.f0.accept(this);
      n.f1.accept(this);
   }

   /**
    * f0 -> "{"
    * f1 -> ( Statement() )*
    * f2 -> "}"
    */
   public void visit(StatementBlock n) {
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
   }

   /**
    * f0 -> Label()
    * f1 -> Var()
    * f2 -> "="
    * f3 -> Varl()
    * f4 -> "+"
    * f5 -> Varl()
    */
   public void visit(PlusStatement n) {
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      n.f3.accept(this);
      n.f4.accept(this);
      n.f5.accept(this);
   }

   /**
    * f0 -> Label()
    * f1 -> Var()
    * f2 -> "="
    * f3 -> Varl()
    * f4 -> "-"
    * f5 -> Varl()
    */
   public void visit(MinusStatement n) {
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      n.f3.accept(this);
      n.f4.accept(this);
      n.f5.accept(this);
   }

   /**
    * f0 -> Label()
    * f1 -> Var()
    * f2 -> "="
    * f3 -> "new"
    * f4 -> Identifier()
    * f5 -> "("
    * f6 -> ")"
    */
   public void visit(NewStatement n) {
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      n.f3.accept(this);
      n.f4.accept(this);
      n.f5.accept(this);
      n.f6.accept(this);
   }

   /**
    * f0 -> [ Var() ( VarsRest() )* ]
    */
   public void visit(Vars n) {
      n.f0.accept(this);
   }

   /**
    * f0 -> ","
    * f1 -> Var()
    */
   public void visit(VarsRest n) {
      n.f0.accept(this);
      n.f1.accept(this);
   }

   /**
    * f0 -> [ Varl() ( VarlsRest() )* ]
    */
   public void visit(Varls n) {
      n.f0.accept(this);
   }

   /**
    * f0 -> ","
    * f1 -> Varl()
    */
   public void visit(VarlsRest n) {
      n.f0.accept(this);
      n.f1.accept(this);
   }

   /**
    * f0 -> Var()
    *       | Val()
    */
   public void visit(Varl n) {
      n.f0.accept(this);
   }

   /**
    * f0 -> Identifier()
    */
   public void visit(Var n) {
      n.f0.accept(this);
   }

   /**
    * f0 -> IntVal()
    *       | Bot()
    *       | Abort()
    *       | Commit()
    *       | Ok()
    *       | Running()
    */
   public void visit(Val n) {
      n.f0.accept(this);
   }

   /**
    * f0 -> IntegerLiteral()
    */
   public void visit(IntVal n) {
      n.f0.accept(this);
   }

   /**
    * f0 -> "\\bot"
    */
   public void visit(Bot n) {
      n.f0.accept(this);
   }

   /**
    * f0 -> "\\A"
    */
   public void visit(Abort n) {
      n.f0.accept(this);
   }

   /**
    * f0 -> "\\C"
    */
   public void visit(Commit n) {
      n.f0.accept(this);
   }

   /**
    * f0 -> "\\Ok"
    */
   public void visit(Ok n) {
      n.f0.accept(this);
   }

   /**
    * f0 -> "\\R"
    */
   public void visit(Running n) {
      n.f0.accept(this);
   }

   /**
    * f0 -> OrExp()
    */
   public void visit(BoolExp n) {
      n.f0.accept(this);
   }

   /**
    * f0 -> AndExp()
    * f1 -> ( OrExpRest() )*
    */
   public void visit(OrExp n) {
      n.f0.accept(this);
      n.f1.accept(this);
   }

   /**
    * f0 -> "||"
    * f1 -> AndExp()
    */
   public void visit(OrExpRest n) {
      n.f0.accept(this);
      n.f1.accept(this);
   }

   /**
    * f0 -> NotExp()
    * f1 -> ( AndExpRest() )*
    */
   public void visit(AndExp n) {
      n.f0.accept(this);
      n.f1.accept(this);
   }

   /**
    * f0 -> "&&"
    * f1 -> NotExp()
    */
   public void visit(AndExpRest n) {
      n.f0.accept(this);
      n.f1.accept(this);
   }

   /**
    * f0 -> ( "!" )?
    * f1 -> Atom()
    */
   public void visit(NotExp n) {
      n.f0.accept(this);
      n.f1.accept(this);
   }

   /**
    * f0 -> ParExp()
    *       | RelExp()
    */
   public void visit(Atom n) {
      n.f0.accept(this);
   }

   /**
    * f0 -> "("
    * f1 -> BoolExp()
    * f2 -> ")"
    */
   public void visit(ParExp n) {
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
   }

   /**
    * f0 -> EqExp()
    *       | IneqExp()
    *       | LTExp()
    *       | GTExp()
    */
   public void visit(RelExp n) {
      n.f0.accept(this);
   }

   /**
    * f0 -> Varl()
    * f1 -> "="
    * f2 -> Varl()
    */
   public void visit(EqExp n) {
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
   }

   /**
    * f0 -> Varl()
    * f1 -> "!="
    * f2 -> Varl()
    */
   public void visit(IneqExp n) {
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
   }

   /**
    * f0 -> Varl()
    * f1 -> "<"
    * f2 -> Varl()
    */
   public void visit(LTExp n) {
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
   }

   /**
    * f0 -> Varl()
    * f1 -> ">"
    * f2 -> Varl()
    */
   public void visit(GTExp n) {
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
   }

   /**
    * f0 -> StatementBlock()
    * f1 -> ( ParBlocksRest() )*
    */
   public void visit(ParBlocks n) {
      n.f0.accept(this);
      n.f1.accept(this);
   }

   /**
    * f0 -> "||"
    * f1 -> StatementBlock()
    */
   public void visit(ParBlocksRest n) {
      n.f0.accept(this);
      n.f1.accept(this);
   }

   /**
    * f0 -> Order()
    * f1 -> ( OrdersRest() )*
    */
   public void visit(Orders n) {
      n.f0.accept(this);
      n.f1.accept(this);
   }

   /**
    * f0 -> "&&"
    * f1 -> Order()
    */
   public void visit(OrdersRest n) {
      n.f0.accept(this);
      n.f1.accept(this);
   }

   /**
    * f0 -> Identifier()
    * f1 -> "->"
    * f2 -> Identifier()
    */
   public void visit(Order n) {
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
   }

   /**
    * f0 -> OrAsser()
    */
   public void visit(Asser n) {
      n.f0.accept(this);
   }

   /**
    * f0 -> AndAsser()
    * f1 -> ( OrAsserRest() )*
    */
   public void visit(OrAsser n) {
      n.f0.accept(this);
      n.f1.accept(this);
   }

   /**
    * f0 -> "\\/"
    * f1 -> AndAsser()
    */
   public void visit(OrAsserRest n) {
      n.f0.accept(this);
      n.f1.accept(this);
   }

   /**
    * f0 -> NotAsser()
    * f1 -> ( AndAsserRest() )*
    */
   public void visit(AndAsser n) {
      n.f0.accept(this);
      n.f1.accept(this);
   }

   /**
    * f0 -> "/\\"
    * f1 -> NotAsser()
    */
   public void visit(AndAsserRest n) {
      n.f0.accept(this);
      n.f1.accept(this);
   }

   /**
    * f0 -> ( "~" )?
    * f1 -> AtomAsser()
    */
   public void visit(NotAsser n) {
      n.f0.accept(this);
      n.f1.accept(this);
   }

   /**
    * f0 -> EqualAsser()
    *       | ExecAsser()
    *       | OrderAsser()
    *       | ParAsser()
    *       | False()
    *       | True()
    */
   public void visit(AtomAsser n) {
      n.f0.accept(this);
   }

   /**
    * f0 -> "false"
    */
   public void visit(False n) {
      n.f0.accept(this);
   }

   /**
    * f0 -> "true"
    */
   public void visit(True n) {
      n.f0.accept(this);
   }

   /**
    * f0 -> "("
    * f1 -> OrAsser()
    * f2 -> ")"
    */
   public void visit(ParAsser n) {
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
   }

   /**
    * f0 -> Var()
    * f1 -> "="
    * f2 -> Val()
    */
   public void visit(EqualAsser n) {
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
   }

   /**
    * f0 -> "exec"
    * f1 -> "("
    * f2 -> Identifier()
    * f3 -> ")"
    */
   public void visit(ExecAsser n) {
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      n.f3.accept(this);
   }

   /**
    * f0 -> Identifier()
    * f1 -> "\\prec"
    * f2 -> Identifier()
    */
   public void visit(OrderAsser n) {
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
   }

   /**
    * f0 -> Label()
    * f1 -> "return"
    * f2 -> ( Varl() )?
    */
   public void visit(Return n) {
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
   }

   /**
    * f0 -> <INTEGER_LITERAL>
    */
   public void visit(IntegerLiteral n) {
      n.f0.accept(this);
   }

   /**
    * f0 -> <STRING_LITERAL>
    */
   public void visit(StringLiteral n) {
      n.f0.accept(this);
   }

   /**
    * f0 -> <IDENTIFIER>
    */
   public void visit(Identifier n) {
      n.f0.accept(this);
   }

}
