//
// Generated by JTB 1.3.2
//

package speclang.spec.syntaxanalysis.visitor;
import speclang.spec.syntaxanalysis.syntaxtree.*;
import java.util.*;

/**
 * Provides default methods which visit each node in the tree in depth-first
 * order.  Your visitors may extend this class.
 */
public class GJDepthFirst<R,A> implements GJVisitor<R,A> {
   //
   // Auto class visitors--probably don't need to be overridden.
   //
   public R visit(NodeList n, A argu) {
      R _ret=null;
      int _count=0;
      for ( Enumeration<Node> e = n.elements(); e.hasMoreElements(); ) {
         e.nextElement().accept(this,argu);
         _count++;
      }
      return _ret;
   }

   public R visit(NodeListOptional n, A argu) {
      if ( n.present() ) {
         R _ret=null;
         int _count=0;
         for ( Enumeration<Node> e = n.elements(); e.hasMoreElements(); ) {
            e.nextElement().accept(this,argu);
            _count++;
         }
         return _ret;
      }
      else
         return null;
   }

   public R visit(NodeOptional n, A argu) {
      if ( n.present() )
         return n.node.accept(this,argu);
      else
         return null;
   }

   public R visit(NodeSequence n, A argu) {
      R _ret=null;
      int _count=0;
      for ( Enumeration<Node> e = n.elements(); e.hasMoreElements(); ) {
         e.nextElement().accept(this,argu);
         _count++;
      }
      return _ret;
   }

   public R visit(NodeToken n, A argu) { return null; }

   //
   // User-generated visitor methods below
   //

   /**
    * f0 -> ( Struct() )?
    * f1 -> Identifier()
    * f2 -> "{"
    * f3 -> ( Decl() )*
    * f4 -> ( Def() )*
    * f5 -> "main"
    * f6 -> "{"
    * f7 -> ParBlocks()
    * f8 -> "}"
    * f9 -> ( "order" "{" Orders() "}" )?
    * f10 -> "spec"
    * f11 -> "{"
    * f12 -> Asser()
    * f13 -> "}"
    * f14 -> "}"
    * f15 -> <EOF>
    */
   public R visit(File n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
      n.f6.accept(this, argu);
      n.f7.accept(this, argu);
      n.f8.accept(this, argu);
      n.f9.accept(this, argu);
      n.f10.accept(this, argu);
      n.f11.accept(this, argu);
      n.f12.accept(this, argu);
      n.f13.accept(this, argu);
      n.f14.accept(this, argu);
      n.f15.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> AtomicRegDecl()
    *       | AtomicCASRegDecl()
    *       | RegDecl()
    *       | LockDecl()
    *       | TryLockDecl()
    */
   public R visit(Decl n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> Obj()
    * f1 -> ":"
    * f2 -> ( "TLocal" )?
    * f3 -> "AtomicRegister"
    * f4 -> ( "[" IntegerLiteral() "]" )?
    */
   public R visit(AtomicRegDecl n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> Obj()
    * f1 -> ":"
    * f2 -> ( "TLocal" )?
    * f3 -> "AtomicCASRegister"
    * f4 -> ( "[" IntegerLiteral() "]" )?
    */
   public R visit(AtomicCASRegDecl n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> Obj()
    * f1 -> ":"
    * f2 -> ( "TLocal" )?
    * f3 -> "BasicRegister"
    * f4 -> ( "[" IntegerLiteral() "]" )?
    */
   public R visit(RegDecl n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> Obj()
    * f1 -> ":"
    * f2 -> ( "TLocal" )?
    * f3 -> "Lock"
    * f4 -> ( "[" IntegerLiteral() "]" )?
    */
   public R visit(LockDecl n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> Obj()
    * f1 -> ":"
    * f2 -> ( "TLocal" )?
    * f3 -> "TryLock"
    * f4 -> ( "[" IntegerLiteral() "]" )?
    */
   public R visit(TryLockDecl n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> Identifier()
    */
   public R visit(Obj n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> "def"
    * f1 -> Name()
    * f2 -> "("
    * f3 -> Vars()
    * f4 -> ")"
    * f5 -> StatementBlock()
    */
   public R visit(Def n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> Identifier()
    */
   public R visit(Name n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> Identifier()
    * f1 -> "{"
    * f2 -> ( Decl() )*
    * f3 -> "}"
    */
   public R visit(Struct n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> MethodCall()
    *       | IfThenElse()
    *       | StatementBlock()
    *       | Return()
    *       | PlusStatement()
    *       | MinusStatement()
    *       | NewStatement()
    *       | FieldMethodCall()
    */
   public R visit(Statement n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> ( Identifier() ">" )?
    */
   public R visit(Label n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> Label()
    * f1 -> ( Var() "=" )?
    * f2 -> ( Receiver() )?
    * f3 -> Name()
    * f4 -> "("
    * f5 -> Varls()
    * f6 -> ")"
    */
   public R visit(MethodCall n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
      n.f6.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> Label()
    * f1 -> ( Var() "=" )?
    * f2 -> Var()
    * f3 -> "."
    * f4 -> Receiver()
    * f5 -> Name()
    * f6 -> "("
    * f7 -> Varls()
    * f8 -> ")"
    */
   public R visit(FieldMethodCall n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
      n.f6.accept(this, argu);
      n.f7.accept(this, argu);
      n.f8.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> "["
    * f1 -> Varl()
    * f2 -> "]"
    */
   public R visit(Index n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> Obj()
    * f1 -> ( Index() )?
    * f2 -> "."
    */
   public R visit(Receiver n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> Label()
    * f1 -> "if"
    * f2 -> "("
    * f3 -> BoolExp()
    * f4 -> ")"
    * f5 -> Statement()
    * f6 -> [ ElseClause() ]
    */
   public R visit(IfThenElse n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
      n.f6.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> "else"
    * f1 -> Statement()
    */
   public R visit(ElseClause n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> "{"
    * f1 -> ( Statement() )*
    * f2 -> "}"
    */
   public R visit(StatementBlock n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> Label()
    * f1 -> Var()
    * f2 -> "="
    * f3 -> Varl()
    * f4 -> "+"
    * f5 -> Varl()
    */
   public R visit(PlusStatement n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> Label()
    * f1 -> Var()
    * f2 -> "="
    * f3 -> Varl()
    * f4 -> "-"
    * f5 -> Varl()
    */
   public R visit(MinusStatement n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> Label()
    * f1 -> Var()
    * f2 -> "="
    * f3 -> "new"
    * f4 -> Identifier()
    * f5 -> "("
    * f6 -> ")"
    */
   public R visit(NewStatement n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
      n.f6.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> [ Var() ( VarsRest() )* ]
    */
   public R visit(Vars n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> ","
    * f1 -> Var()
    */
   public R visit(VarsRest n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> [ Varl() ( VarlsRest() )* ]
    */
   public R visit(Varls n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> ","
    * f1 -> Varl()
    */
   public R visit(VarlsRest n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> Var()
    *       | Val()
    */
   public R visit(Varl n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> Identifier()
    */
   public R visit(Var n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> IntVal()
    *       | Bot()
    *       | Abort()
    *       | Commit()
    *       | Ok()
    *       | Running()
    */
   public R visit(Val n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> IntegerLiteral()
    */
   public R visit(IntVal n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> "\\bot"
    */
   public R visit(Bot n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> "\\A"
    */
   public R visit(Abort n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> "\\C"
    */
   public R visit(Commit n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> "\\Ok"
    */
   public R visit(Ok n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> "\\R"
    */
   public R visit(Running n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> OrExp()
    */
   public R visit(BoolExp n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> AndExp()
    * f1 -> ( OrExpRest() )*
    */
   public R visit(OrExp n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> "||"
    * f1 -> AndExp()
    */
   public R visit(OrExpRest n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> NotExp()
    * f1 -> ( AndExpRest() )*
    */
   public R visit(AndExp n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> "&&"
    * f1 -> NotExp()
    */
   public R visit(AndExpRest n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> ( "!" )?
    * f1 -> Atom()
    */
   public R visit(NotExp n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> ParExp()
    *       | RelExp()
    */
   public R visit(Atom n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> "("
    * f1 -> BoolExp()
    * f2 -> ")"
    */
   public R visit(ParExp n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> EqExp()
    *       | IneqExp()
    *       | LTExp()
    *       | GTExp()
    */
   public R visit(RelExp n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> Varl()
    * f1 -> "="
    * f2 -> Varl()
    */
   public R visit(EqExp n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> Varl()
    * f1 -> "!="
    * f2 -> Varl()
    */
   public R visit(IneqExp n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> Varl()
    * f1 -> "<"
    * f2 -> Varl()
    */
   public R visit(LTExp n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> Varl()
    * f1 -> ">"
    * f2 -> Varl()
    */
   public R visit(GTExp n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> StatementBlock()
    * f1 -> ( ParBlocksRest() )*
    */
   public R visit(ParBlocks n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> "||"
    * f1 -> StatementBlock()
    */
   public R visit(ParBlocksRest n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> Order()
    * f1 -> ( OrdersRest() )*
    */
   public R visit(Orders n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> "&&"
    * f1 -> Order()
    */
   public R visit(OrdersRest n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> Identifier()
    * f1 -> "->"
    * f2 -> Identifier()
    */
   public R visit(Order n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> OrAsser()
    */
   public R visit(Asser n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> AndAsser()
    * f1 -> ( OrAsserRest() )*
    */
   public R visit(OrAsser n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> "\\/"
    * f1 -> AndAsser()
    */
   public R visit(OrAsserRest n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> NotAsser()
    * f1 -> ( AndAsserRest() )*
    */
   public R visit(AndAsser n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> "/\\"
    * f1 -> NotAsser()
    */
   public R visit(AndAsserRest n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> ( "~" )?
    * f1 -> AtomAsser()
    */
   public R visit(NotAsser n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> EqualAsser()
    *       | ExecAsser()
    *       | OrderAsser()
    *       | ParAsser()
    *       | False()
    *       | True()
    */
   public R visit(AtomAsser n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> "false"
    */
   public R visit(False n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> "true"
    */
   public R visit(True n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> "("
    * f1 -> OrAsser()
    * f2 -> ")"
    */
   public R visit(ParAsser n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> Var()
    * f1 -> "="
    * f2 -> Val()
    */
   public R visit(EqualAsser n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> "exec"
    * f1 -> "("
    * f2 -> Identifier()
    * f3 -> ")"
    */
   public R visit(ExecAsser n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> Identifier()
    * f1 -> "\\prec"
    * f2 -> Identifier()
    */
   public R visit(OrderAsser n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> Label()
    * f1 -> "return"
    * f2 -> ( Varl() )?
    */
   public R visit(Return n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <INTEGER_LITERAL>
    */
   public R visit(IntegerLiteral n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <STRING_LITERAL>
    */
   public R visit(StringLiteral n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <IDENTIFIER>
    */
   public R visit(Identifier n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

}
