//
// Generated by JTB 1.3.2
//

package speclang.spec.syntaxanalysis.visitor;
import speclang.spec.syntaxanalysis.syntaxtree.*;
import java.util.*;

/**
 * All GJ visitors with no argument must implement this interface.
 */

public interface GJNoArguVisitor<R> {

   //
   // GJ Auto class visitors with no argument
   //

   public R visit(NodeList n);
   public R visit(NodeListOptional n);
   public R visit(NodeOptional n);
   public R visit(NodeSequence n);
   public R visit(NodeToken n);

   //
   // User-generated visitor methods below
   //

   /**
    * f0 -> ( Struct() )?
    * f1 -> Identifier()
    * f2 -> "{"
    * f3 -> ( Decl() )*
    * f4 -> ( Def() )*
    * f5 -> "main"
    * f6 -> "{"
    * f7 -> ParBlocks()
    * f8 -> "}"
    * f9 -> ( "order" "{" Orders() "}" )?
    * f10 -> "spec"
    * f11 -> "{"
    * f12 -> Asser()
    * f13 -> "}"
    * f14 -> "}"
    * f15 -> <EOF>
    */
   public R visit(File n);

   /**
    * f0 -> AtomicRegDecl()
    *       | AtomicCASRegDecl()
    *       | RegDecl()
    *       | LockDecl()
    *       | TryLockDecl()
    */
   public R visit(Decl n);

   /**
    * f0 -> Obj()
    * f1 -> ":"
    * f2 -> ( "TLocal" )?
    * f3 -> "AtomicRegister"
    * f4 -> ( "[" IntegerLiteral() "]" )?
    */
   public R visit(AtomicRegDecl n);

   /**
    * f0 -> Obj()
    * f1 -> ":"
    * f2 -> ( "TLocal" )?
    * f3 -> "AtomicCASRegister"
    * f4 -> ( "[" IntegerLiteral() "]" )?
    */
   public R visit(AtomicCASRegDecl n);

   /**
    * f0 -> Obj()
    * f1 -> ":"
    * f2 -> ( "TLocal" )?
    * f3 -> "BasicRegister"
    * f4 -> ( "[" IntegerLiteral() "]" )?
    */
   public R visit(RegDecl n);

   /**
    * f0 -> Obj()
    * f1 -> ":"
    * f2 -> ( "TLocal" )?
    * f3 -> "Lock"
    * f4 -> ( "[" IntegerLiteral() "]" )?
    */
   public R visit(LockDecl n);

   /**
    * f0 -> Obj()
    * f1 -> ":"
    * f2 -> ( "TLocal" )?
    * f3 -> "TryLock"
    * f4 -> ( "[" IntegerLiteral() "]" )?
    */
   public R visit(TryLockDecl n);

   /**
    * f0 -> Identifier()
    */
   public R visit(Obj n);

   /**
    * f0 -> "def"
    * f1 -> Name()
    * f2 -> "("
    * f3 -> Vars()
    * f4 -> ")"
    * f5 -> StatementBlock()
    */
   public R visit(Def n);

   /**
    * f0 -> Identifier()
    */
   public R visit(Name n);

   /**
    * f0 -> Identifier()
    * f1 -> "{"
    * f2 -> ( Decl() )*
    * f3 -> "}"
    */
   public R visit(Struct n);

   /**
    * f0 -> MethodCall()
    *       | IfThenElse()
    *       | StatementBlock()
    *       | Return()
    *       | PlusStatement()
    *       | MinusStatement()
    *       | NewStatement()
    *       | FieldMethodCall()
    */
   public R visit(Statement n);

   /**
    * f0 -> ( Identifier() ">" )?
    */
   public R visit(Label n);

   /**
    * f0 -> Label()
    * f1 -> ( Var() "=" )?
    * f2 -> ( Receiver() )?
    * f3 -> Name()
    * f4 -> "("
    * f5 -> Varls()
    * f6 -> ")"
    */
   public R visit(MethodCall n);

   /**
    * f0 -> Label()
    * f1 -> ( Var() "=" )?
    * f2 -> Var()
    * f3 -> "."
    * f4 -> Receiver()
    * f5 -> Name()
    * f6 -> "("
    * f7 -> Varls()
    * f8 -> ")"
    */
   public R visit(FieldMethodCall n);

   /**
    * f0 -> "["
    * f1 -> Varl()
    * f2 -> "]"
    */
   public R visit(Index n);

   /**
    * f0 -> Obj()
    * f1 -> ( Index() )?
    * f2 -> "."
    */
   public R visit(Receiver n);

   /**
    * f0 -> Label()
    * f1 -> "if"
    * f2 -> "("
    * f3 -> BoolExp()
    * f4 -> ")"
    * f5 -> Statement()
    * f6 -> [ ElseClause() ]
    */
   public R visit(IfThenElse n);

   /**
    * f0 -> "else"
    * f1 -> Statement()
    */
   public R visit(ElseClause n);

   /**
    * f0 -> "{"
    * f1 -> ( Statement() )*
    * f2 -> "}"
    */
   public R visit(StatementBlock n);

   /**
    * f0 -> Label()
    * f1 -> Var()
    * f2 -> "="
    * f3 -> Varl()
    * f4 -> "+"
    * f5 -> Varl()
    */
   public R visit(PlusStatement n);

   /**
    * f0 -> Label()
    * f1 -> Var()
    * f2 -> "="
    * f3 -> Varl()
    * f4 -> "-"
    * f5 -> Varl()
    */
   public R visit(MinusStatement n);

   /**
    * f0 -> Label()
    * f1 -> Var()
    * f2 -> "="
    * f3 -> "new"
    * f4 -> Identifier()
    * f5 -> "("
    * f6 -> ")"
    */
   public R visit(NewStatement n);

   /**
    * f0 -> [ Var() ( VarsRest() )* ]
    */
   public R visit(Vars n);

   /**
    * f0 -> ","
    * f1 -> Var()
    */
   public R visit(VarsRest n);

   /**
    * f0 -> [ Varl() ( VarlsRest() )* ]
    */
   public R visit(Varls n);

   /**
    * f0 -> ","
    * f1 -> Varl()
    */
   public R visit(VarlsRest n);

   /**
    * f0 -> Var()
    *       | Val()
    */
   public R visit(Varl n);

   /**
    * f0 -> Identifier()
    */
   public R visit(Var n);

   /**
    * f0 -> IntVal()
    *       | Bot()
    *       | Abort()
    *       | Commit()
    *       | Ok()
    *       | Running()
    */
   public R visit(Val n);

   /**
    * f0 -> IntegerLiteral()
    */
   public R visit(IntVal n);

   /**
    * f0 -> "\\bot"
    */
   public R visit(Bot n);

   /**
    * f0 -> "\\A"
    */
   public R visit(Abort n);

   /**
    * f0 -> "\\C"
    */
   public R visit(Commit n);

   /**
    * f0 -> "\\Ok"
    */
   public R visit(Ok n);

   /**
    * f0 -> "\\R"
    */
   public R visit(Running n);

   /**
    * f0 -> OrExp()
    */
   public R visit(BoolExp n);

   /**
    * f0 -> AndExp()
    * f1 -> ( OrExpRest() )*
    */
   public R visit(OrExp n);

   /**
    * f0 -> "||"
    * f1 -> AndExp()
    */
   public R visit(OrExpRest n);

   /**
    * f0 -> NotExp()
    * f1 -> ( AndExpRest() )*
    */
   public R visit(AndExp n);

   /**
    * f0 -> "&&"
    * f1 -> NotExp()
    */
   public R visit(AndExpRest n);

   /**
    * f0 -> ( "!" )?
    * f1 -> Atom()
    */
   public R visit(NotExp n);

   /**
    * f0 -> ParExp()
    *       | RelExp()
    */
   public R visit(Atom n);

   /**
    * f0 -> "("
    * f1 -> BoolExp()
    * f2 -> ")"
    */
   public R visit(ParExp n);

   /**
    * f0 -> EqExp()
    *       | IneqExp()
    *       | LTExp()
    *       | GTExp()
    */
   public R visit(RelExp n);

   /**
    * f0 -> Varl()
    * f1 -> "="
    * f2 -> Varl()
    */
   public R visit(EqExp n);

   /**
    * f0 -> Varl()
    * f1 -> "!="
    * f2 -> Varl()
    */
   public R visit(IneqExp n);

   /**
    * f0 -> Varl()
    * f1 -> "<"
    * f2 -> Varl()
    */
   public R visit(LTExp n);

   /**
    * f0 -> Varl()
    * f1 -> ">"
    * f2 -> Varl()
    */
   public R visit(GTExp n);

   /**
    * f0 -> StatementBlock()
    * f1 -> ( ParBlocksRest() )*
    */
   public R visit(ParBlocks n);

   /**
    * f0 -> "||"
    * f1 -> StatementBlock()
    */
   public R visit(ParBlocksRest n);

   /**
    * f0 -> Order()
    * f1 -> ( OrdersRest() )*
    */
   public R visit(Orders n);

   /**
    * f0 -> "&&"
    * f1 -> Order()
    */
   public R visit(OrdersRest n);

   /**
    * f0 -> Identifier()
    * f1 -> "->"
    * f2 -> Identifier()
    */
   public R visit(Order n);

   /**
    * f0 -> OrAsser()
    */
   public R visit(Asser n);

   /**
    * f0 -> AndAsser()
    * f1 -> ( OrAsserRest() )*
    */
   public R visit(OrAsser n);

   /**
    * f0 -> "\\/"
    * f1 -> AndAsser()
    */
   public R visit(OrAsserRest n);

   /**
    * f0 -> NotAsser()
    * f1 -> ( AndAsserRest() )*
    */
   public R visit(AndAsser n);

   /**
    * f0 -> "/\\"
    * f1 -> NotAsser()
    */
   public R visit(AndAsserRest n);

   /**
    * f0 -> ( "~" )?
    * f1 -> AtomAsser()
    */
   public R visit(NotAsser n);

   /**
    * f0 -> EqualAsser()
    *       | ExecAsser()
    *       | OrderAsser()
    *       | ParAsser()
    *       | False()
    *       | True()
    */
   public R visit(AtomAsser n);

   /**
    * f0 -> "false"
    */
   public R visit(False n);

   /**
    * f0 -> "true"
    */
   public R visit(True n);

   /**
    * f0 -> "("
    * f1 -> OrAsser()
    * f2 -> ")"
    */
   public R visit(ParAsser n);

   /**
    * f0 -> Var()
    * f1 -> "="
    * f2 -> Val()
    */
   public R visit(EqualAsser n);

   /**
    * f0 -> "exec"
    * f1 -> "("
    * f2 -> Identifier()
    * f3 -> ")"
    */
   public R visit(ExecAsser n);

   /**
    * f0 -> Identifier()
    * f1 -> "\\prec"
    * f2 -> Identifier()
    */
   public R visit(OrderAsser n);

   /**
    * f0 -> Label()
    * f1 -> "return"
    * f2 -> ( Varl() )?
    */
   public R visit(Return n);

   /**
    * f0 -> <INTEGER_LITERAL>
    */
   public R visit(IntegerLiteral n);

   /**
    * f0 -> <STRING_LITERAL>
    */
   public R visit(StringLiteral n);

   /**
    * f0 -> <IDENTIFIER>
    */
   public R visit(Identifier n);

}

